#include "Main.h"
#include "Blood.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
const static float 
	MinSize=0.02f, MaxSize=0.05f, 
	RandColor=0.2f;
const static int
	MinTime=20, MaxTime=100;
const static D3DXVECTOR3
	InitPos(-0.5f, 2.7f, -0.4f), 
	MinV(-0.1f, 0.1f, -0.06f), 
	MaxV(0.1f, 0.12f, -0.07f),
	APos(0, -0.005f, 0);

//==============================================================
// H

// RXgN^
CEachBlood::CEachBlood(D3DXVECTOR3 base_color) 
:	BaseColor(base_color)
{
	// eNX`W
	Vertex[0].UV=D3DXVECTOR2(0, 0);
	Vertex[1].UV=D3DXVECTOR2(1, 0);
	Vertex[2].UV=D3DXVECTOR2(0, 1);
	Vertex[3].UV=D3DXVECTOR2(1, 1);
	
	// 
	Init();
	
	// ŏɓH܂ĔȂ悤ɂ邽߂̏
	for (int i=0, n=Rand1()*MaxTime; i<n; i++) Move();
}

// 
void CEachBlood::Init() {
	
	// WAxATCY
	Pos=InitPos;
	VPos=D3DXVECTOR3(
		MinV.x+(MaxV.x-MinV.x)*(Rand1()+Rand1())*0.5f,
		MinV.y+(MaxV.y-MinV.y)*(Rand1()+Rand1())*0.5f, 
		MinV.z+(MaxV.z-MinV.z)*(Rand1()+Rand1())*0.5f);
	Size=MinSize+(MaxSize-MinSize)*Rand1();

	// F
	float c=Rand05()*RandColor;
	Color=BaseColor+D3DXVECTOR3(c, c, c);

	// 
	Time=0;
	EndTime=MinTime+(MaxTime-MinTime)*Rand1();
}

// ړ
void CEachBlood::Move() {

	// WAxAԂ̍XV
	Pos+=VPos;
	VPos+=APos;
	Time++;
	
	// IԂɒBĂя
	if (Time>=EndTime) Init();
}

// `
void CEachBlood::Draw(
	LPDIRECT3DDEVICE9 device, 
	ID3DXEffect* effect, 
	D3DXMATRIX* wview
) {
	// SW[hr[ϊ
	D3DXVECTOR4 v=D3DXVECTOR4(Pos, 1);
	D3DXVec4Transform(&v, &v, wview);

	// _ɑ΂Đʂ悤ɒ_Wݒ
	Vertex[0].Pos=D3DXVECTOR3(v.x-Size, v.y+Size, v.z);
	Vertex[1].Pos=D3DXVECTOR3(v.x+Size, v.y+Size, v.z);
	Vertex[2].Pos=D3DXVECTOR3(v.x-Size, v.y-Size, v.z);
	Vertex[3].Pos=D3DXVECTOR3(v.x+Size, v.y-Size, v.z);

	// F
	D3DXVECTOR4 color(
		Color.x, Color.y, Color.z, 
		sin(D3DX_PI*(float)(EndTime-Time)/EndTime));
	effect->SetVector("Color", &color);	

	// v~eBu̕`
	UINT p, np;
	effect->Begin(&np, 0);
	for (p=0; p<np; p++) {
		effect->BeginPass(p);
		device->DrawPrimitiveUP(
			D3DPT_TRIANGLESTRIP, 2, 
			Vertex, sizeof(BLOOD_VERTEX));
		effect->EndPass();
	}
	effect->End();
}


//==============================================================
// Ԃ̃f

// RXgN^
CBlood::CBlood(
	CMain* main, string title, int mode,
	int blood_count, D3DXVECTOR3 blood_color,
	float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), Mode(mode), 
	BloodCount(blood_count), 
	Yaw(0), VYaw(vyaw), From(from), Lookat(lookat)
{
	// bṼ[h
	Mesh=LoadMesh("SceneBlood.x");

	// GtFNg̃[h
	Effect=LoadEffect("Smoke.fx");

	// eNX`̃[h
	Texture=LoadTexture("Blood.png");
	
	// H̍쐬
	Blood=new CEachBlood*[BloodCount];
	for (int i=0; i<BloodCount; i++) {
		Blood[i]=new CEachBlood(blood_color);
	}
}

// fXgN^
CBlood::~CBlood() {
	delete[] Blood;
}
	
// ړ
void CBlood::Move() {

	// V[̉]
	Yaw+=VYaw;

	// H𓮂
	for (int i=0; i<BloodCount; i++) Blood[i]->Move();
}

// `
void CBlood::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!Texture) { Error="Texture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, 
		D3DXVECTOR3(0, 0, 0), D3DXVECTOR3(1, -1, 1), 
		D3DXCOLOR(0.4f, 0.4f, 0.8f, 0), 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// _`AsAeNX`AeNjbN̐ݒ
	Device->SetFVF(D3DFVF_BLOOD_VERTEX);
	Effect->SetMatrix("Proj", &proj);
	Effect->SetTexture("Tex", Texture);
	Effect->SetTechnique("Blood");

	// [hr[švZ
	D3DXMATRIX wview;
	D3DXMatrixMultiply(&wview, &world, &view);

	// H̕`
	for (int i=0; i<BloodCount; i++) {
		Blood[i]->Draw(Device, Effect, &wview);
	}
}

