#include "Main.h"
#include "Blur.h"


//==============================================================
// u[

// RXgN^
CBlur::CBlur(CMain* main, string title, float alpha, float scale, float roll)
:	CDemo(main, title),
	Target(0), ObjYaw(0), EnvYaw(0), Alpha(alpha), 
	Roll(roll), Scale(scale)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneTrain_Obj.x");
	MeshEnv=LoadMesh("SceneTrain_Env.x");
}

// fXgN^
CBlur::~CBlur() {
}
	
// ړ
void CBlur::Move() {
	ObjYaw+=0.05f;
	EnvYaw+=0.01f;
	Target=1-Target;
}

// `
void CBlur::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 4, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`OɃbV`
	SetRenderTarget(WorkTexture[Target], WorkDepthStencil[Target]);
	Graphics->Clear(BGColor);

	// ̂̕`
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, ObjYaw);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshObj->Draw();

	// wi̕`
	D3DXMatrixIdentity(&world);
	D3DXMatrixRotationY(&world, EnvYaw);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshEnv->Draw();

	// eNX`PeNX`Oɕ`
	float 
		r=Roll*D3DX_PI*2, c=cos(r), s=sin(r), 
		dx=((-w*c+h*s)*Scale+w)/2, 
		dy=((-w*s-h*c)*Scale+h)/2;
	DrawTexture(
		WorkTexture[1-Target], 
		dx, dy, w-1-dy, dx, dy, h-1-dx, w-1-dx, h-1-dy, 
		0, 0, 1, 1, D3DCOLOR_ARGB((int)(255*Alpha), 255, 255, 255));

	// eNX`Oʂɕ`
	ResetRenderTarget();
	Device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	DrawTexture(WorkTexture[Target], 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	Device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
}
