#include "Main.h"
#include "ColorInOut.h"


//==============================================================
// J[CAEg

// RXgN^
CColorInOut::CColorInOut(CMain* main, string title, D3DXCOLOR color)
:	CDemo(main, title), 
	Color(color), Alpha(1), Time(0), Index(0)
{
	// bṼ[h
	Mesh[0]=LoadMesh("SceneDiningA.x");
	Mesh[1]=LoadMesh("SceneDiningB.x");

	// GtFNg̃[h
	Effect=LoadEffect("FadeInOut.fx");
}

// fXgN^
CColorInOut::~CColorInOut() {
}
	
// ړ
void CColorInOut::Move() {

	// At@l̕ω
	Alpha=cos(D3DX_PI*2*Time*0.002f)*0.5f+0.5f;
	
	// bV̕ω
	Index=(Time+250)/500%2;
	
	// Ԃ̍XV
	Time++;
}

// `
void CColorInOut::Draw() {

	// G[`FbN
	if (!Mesh[0]) { Error="Mesh[0]"; return; }
	if (!Mesh[1]) { Error="Mesh[1]"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(5, 4, -5);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`0ɃbV`
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	Graphics->Clear(BGColor);
	Mesh[Index]->Draw();

	// eNX`1͒PFœhԂ
	SetRenderTarget(WorkTexture[1], WorkDepthStencil[1]);
	Graphics->Clear(Color);

	// eNX`0ƃeNX`1ĉʂɕ`
	ResetRenderTarget();
	Effect->SetFloat("Alpha", Alpha);
	Effect->SetTechnique("Fade");
	Effect->SetTexture("Tex0", WorkTexture[0]);
	Effect->SetTexture("Tex1", WorkTexture[1]);
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
}

