#include "Main.h"
#include "CoverTakibi.h"

// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
const static float 
	InitXZ=0.0f, InitY=1.0f, 
	RandColor=0.2f;

// t@[
#define TEX_SIZE 256
LPDIRECT3DTEXTURE9 CCoverTakibi::FurTexture=NULL;
LPDIRECT3DTEXTURE9 CCoverTakibi::NormalTexture=NULL;

//==============================================================
// 

// RXgN^
CEachCoverTakibi::CEachCoverTakibi(
	D3DXVECTOR3 base_color, float max_xz,
	int min_time, int max_time,
	float min_size, float max_size
)
:	BaseColor(base_color), MaxXZ(max_xz),
	MinTime(min_time), MaxTime(max_time),
	MinSize(min_size), MaxSize(max_size),
	MinVY(MinSize*0.1f), MaxVY(MaxSize*0.1f)
{

	// eNX`W
	Vertex[0].UV=D3DXVECTOR2(0, 0);
	Vertex[1].UV=D3DXVECTOR2(1, 0);
	Vertex[2].UV=D3DXVECTOR2(0, 1);
	Vertex[3].UV=D3DXVECTOR2(1, 1);
	
	// 
	Init();
	for (int i=0, n=Rand1()*MaxTime; i<n; i++) Move();
}

// 
void CEachCoverTakibi::Init() {

	// WAxATCY
	float rad=Rand1()*D3DX_PI*2, xz=Rand05()*MaxXZ;
	Pos=D3DXVECTOR3(
		InitXZ+cos(rad)*xz, InitY, InitXZ);//+sin(rad)*xz);
	VPos=D3DXVECTOR3(
		0, MinVY+(MaxVY-MinVY)*Rand1(), 0);
	Size=MinSize+(MaxSize-MinSize)*Rand1();

	// F
	float c=Rand05()*RandColor;
	Color=BaseColor+D3DXVECTOR3(c, c, c);

	// 
	Time=0;
	EndTime=MinTime+(MaxTime-MinTime)*Rand1();
}

// ړ
void CEachCoverTakibi::Move() {

	// WƎԂ̍XV
	Pos+=VPos;
	Time++;

	// IԂɂȂĂя
	if (Time>=EndTime) Init();
}

// `
void CEachCoverTakibi::Draw(
	LPDIRECT3DDEVICE9 device, ID3DXEffect* FireEffect, D3DXMATRIX* wview
) {
	// _W̐ݒ
	D3DXVECTOR4 v=D3DXVECTOR4(Pos, 1);
	D3DXVec4Transform(&v, &v, wview);
	Vertex[0].Pos=D3DXVECTOR3(v.x-Size, v.y+Size, v.z);
	Vertex[1].Pos=D3DXVECTOR3(v.x+Size, v.y+Size, v.z);
	Vertex[2].Pos=D3DXVECTOR3(v.x-Size, v.y-Size, v.z);
	Vertex[3].Pos=D3DXVECTOR3(v.x+Size, v.y-Size, v.z);

	// F̐ݒ
	D3DXVECTOR4 color(
		Color.x, Color.y, Color.z, 
		sin(D3DX_PI*(float)(EndTime-Time)/EndTime));
	FireEffect->SetVector("Color", &color);

	// v~eBu̕`
	UINT p, np;
	FireEffect->Begin(&np, 0);
	for (p=0; p<np; p++) {
		FireEffect->BeginPass(p);
		device->DrawPrimitiveUP(
			D3DPT_TRIANGLESTRIP, 2, 
			Vertex, sizeof(COVERTAKIBI_VERTEX));
		FireEffect->EndPass();
	}
	FireEffect->End();
}


//==============================================================
// ̃O[v
class CTakibiGroup {
protected:
	D3DXVECTOR3 Pos;
	D3DXVECTOR3 Color;
	float MaxXZ;
	int Count;
	CEachCoverTakibi** Fire;
public:
	CTakibiGroup(D3DXVECTOR3 pos, D3DXVECTOR3 color, int count, 
		float max_xz, int min_time, int max_time, float min_size, float max_size)
	:	Pos(pos), Color(color), Count(count) {
		Fire=new CEachCoverTakibi*[Count];
		for (int i=0; i<Count; i++) {
			Fire[i]=new CEachCoverTakibi(Color, max_xz, min_time, max_time, min_size, max_size);
		}
	}
	void Move() {
		for (int i=0; i<Count; i++) Fire[i]->Move();
	}
	void Draw(
		D3DXMATRIX* world, D3DXMATRIX* view, 
		LPDIRECT3DDEVICE9 device, ID3DXEffect* FireEffect
	) {
		D3DXMATRIX wview, trans;
		D3DXMatrixTranslation(&trans, Pos.x, Pos.y, Pos.z);
		wview=trans**world**view;
		for (int i=0; i<Count; i++) Fire[i]->Draw(device, FireEffect, &wview);
	}
};

static CTakibiGroup* TakibiGroup[]={
	new CTakibiGroup(D3DXVECTOR3(0, -1, 0), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 1000, 2.0f, 10, 60, 0.3f, 0.5f),
	new CTakibiGroup(D3DXVECTOR3(0, 0.5f, 1.7f), D3DXVECTOR3(0.05f, 0.03f, 0.02f), 100, 0.1f, 5, 30, 0.06f, 0.1f),
};
static int TakibiGroupCount=sizeof(TakibiGroup)/sizeof(CTakibiGroup*);


//==============================================================
// \

// RXgN^
CCoverTakibi::CCoverTakibi(
	CMain* main, float vyaw,
	D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, ""), 
	Yaw(0), VYaw(vyaw), CircleYaw(0),
	From(from), Lookat(lookat), LayerCount(20)
{
	// bṼ[h
	Mesh=LoadMesh("SceneCoverTakibi.x");

	// 
	FireEffect=LoadEffect("Smoke.fx");
	FireTexture=LoadTexture("Smoke.png");

	// t@[
	MeshFur=LoadMesh("SceneCoverTakibi_Fur.x");
	FurEffect=LoadEffect("Fur.fx");
}

// fXgN^
CCoverTakibi::~CCoverTakibi() {
	OnLostDevice();
}

// foCXZbg
void CCoverTakibi::OnResetDevice() {
	CDemo::OnResetDevice();

	// t@[}bv̍쐬
	if (!FurTexture) {
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
			D3DPOOL_DEFAULT, &FurTexture, NULL);

		// t@[}bv̕`
		if (FurTexture) {
			Graphics->BeginScene();
			SetRenderTarget(FurTexture, NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
			FurEffect->SetTechnique("MakeFur");
			FurEffect->SetFloat("Density", 300);
			DrawRect(FurEffect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
			Graphics->EndScene();
		}
	}

	// @}bv̍쐬
	if (!NormalTexture) {
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
			D3DPOOL_DEFAULT, &NormalTexture, NULL);

		// @}bv̕`
		if (NormalTexture) {
			Graphics->BeginScene();
			SetRenderTarget(NormalTexture, NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
			FurEffect->SetTechnique("MakeNormal");
			DrawRect(FurEffect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
			Graphics->EndScene();
		}
	}	
}

// foCXXg
void CCoverTakibi::OnLostDevice() {
	CDemo::OnLostDevice();
	SAFE_RELEASE(FurTexture);
}

// ړ
void CCoverTakibi::Move() {

	// V[̉]
	Yaw+=VYaw;
	CircleYaw+=0.01f;

	// 𓮂
	for (int i=0; i<TakibiGroupCount; i++) TakibiGroup[i]->Move();
}

// `
void CCoverTakibi::Draw() {

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	D3DXVECTOR3 LightWVPos=D3DXVECTOR3(0, -1, 0);
	D3DXCOLOR LightColor=D3DXCOLOR(1.0f, 0.8f, 0.5f, 1);
	Graphics->SetLight(0, D3DLIGHT_POINT, LightWVPos, D3DXVECTOR3(0, 0, 0), LightColor, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	//========================================================================
	// V[
	Graphics->Clear();
	Mesh->Draw();

	//========================================================================
	// 
	// At@ufBO̐ݒiZj
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	// _`AsAeNX`AeNjbN̐ݒ
	Device->SetFVF(D3DFVF_COVERTAKIBI_VERTEX);
	FireEffect->SetMatrix("Proj", &proj);
	FireEffect->SetTexture("Tex", FireTexture);
	FireEffect->SetTechnique("Smoke");
	
	// 
	for (int i=0; i<TakibiGroupCount; i++) {
		TakibiGroup[i]->Draw(&world, &view, Device, FireEffect);
	}

	// At@ufBO̐ݒiʏj
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

	//========================================================================
	// t@[
	FurEffect->SetMatrix("World", &world);
	D3DXMATRIX w_view=world*view;
	FurEffect->SetMatrix("WView", &w_view);
	FurEffect->SetMatrix("Proj", &proj);
	D3DXMATRIX wv_proj=w_view*proj;
	FurEffect->SetMatrix("WVProj", &wv_proj);
	FurEffect->SetVector("LightWVPos", (D3DXVECTOR4*)&LightWVPos);
	FurEffect->SetVector("LightColor", (D3DXVECTOR4*)&LightColor);
	FurEffect->SetVector("Ambient", (D3DXVECTOR4*)&ambient);
	FurEffect->SetTechnique("Fur");
	FurEffect->SetTexture("FurTex", FurTexture);
	FurEffect->SetTexture("NormalTex", NormalTexture);
	FurEffect->SetFloat("Power", 4);
	for (int layer=0; layer<LayerCount; layer++) {
		FurEffect->SetFloat("Layer", layer*0.01f);
		FurEffect->SetFloat("Alpha", 1.0f*(LayerCount-layer)/LayerCount);
		DrawMesh(MeshFur, FurEffect);
	}
}

