#ifndef DEMOH
#define DEMOH

#include <string>
using namespace std;
#include "..\LibGame\Graphics.h"
#include "..\LibGame\Mesh.h"
class CMain;


//==============================================================
// ef̊{NX
class CDemo {
protected:

	// CNX
	CMain* Main;
	
	// f̃^CgAG[
	string Title, Error;
	bool PS20();

	// ȅ
	CGraphics* Graphics;
	static LPDIRECT3DDEVICE9 Device;
	string ExePath;

	// _obt@
	LPDIRECT3DVERTEXBUFFER9 VertexBuffer;

	// [NeNX`A[xXeV
	int WorkCount;
	LPDIRECT3DTEXTURE9* WorkTexture;
	LPDIRECT3DSURFACE9* WorkDepthStencil;

	// wiF
	D3DCOLOR BGColor;

	// _O^[QbgA[xobt@
	static LPDIRECT3DSURFACE9 OrgRenderTarget, OrgDepthStencil;

	// bV
	static vector<CMesh*> MeshList;
	static vector<string> MeshName;
	
	// GtFNg
	static vector<ID3DXEffect*> EffectList;
	static vector<string> EffectName;

	// eNX`
	static vector<LPDIRECT3DTEXTURE9> TextureList;
	static vector<string> TextureName;
	
public:

	// RXgN^AfXgN^
	CDemo(CMain* main, string title);
	virtual ~CDemo();
	
	// foCX̏AړA`
	virtual void Init();
	virtual void Move() {}
	virtual void Draw() {}
	virtual void OnLostDevice() {}
	virtual void OnResetDevice() {}
	static void OnLostDeviceStatic();
	static void OnResetDeviceStatic();

	// bV
	CMesh* LoadMesh(string file);
	LPDIRECT3DTEXTURE9 GetTexture(CMesh* mesh, int index);
	void DrawMesh(CMesh* mesh, ID3DXEffect* effect);

	// GtFNg
	ID3DXEffect* LoadEffect(string file);

	// eNX`
	LPDIRECT3DTEXTURE9 LoadTexture(string file);
	void DrawTexture(
		LPDIRECT3DBASETEXTURE9 texture, 
		float x0, float y0, float x1, float y1, 
		float x2, float y2, float x3, float y3, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	);
	void DrawTexture(
		LPDIRECT3DBASETEXTURE9 texture, 
		float x0, float y0, float x1, float y1, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	) {
		DrawTexture(
			texture, x0, y0, x1, y0, x0, y1, 
			x1, y1, u0, v0, u1, v1, diffuse);
	}

	// lp`̕`
	void DrawQuad(
		float x0, float y0, float x1, float y1, 
		float x2, float y2, float x3, float y3, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	);
	void DrawQuad(
		ID3DXEffect* effect, 
		float x0, float y0, float x1, float y1, 
		float x2, float y2, float x3, float y3, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	);
	void DrawRect(
		ID3DXEffect* effect, 
		float x0, float y0, float x1, float y1, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	) {
		DrawQuad(
			effect, x0, y0, x1, y0, x0, y1, 
			x1, y1, u0, v0, u1, v1, diffuse);
	}

	// TvO
	void SetSamplerState(DWORD sampler, DWORD value);

	// _O^[Qbg
	void SetRenderTarget(
		LPDIRECT3DTEXTURE9 texture, 
		LPDIRECT3DSURFACE9 depth_stencil
	);
	void SetRenderTarget(
		LPDIRECT3DCUBETEXTURE9 cube_texture, 
		int face, 
		LPDIRECT3DSURFACE9 depth_stencil
	);
	void ResetRenderTarget();

	// ̎擾
	string GetTitle() { return Title; }
	string GetError() { return Error; }
};


#endif

