//==============================================================
// 萔
float4x4 World;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 Light;
float Width;
float Height;
float NormalScale;
float PixelScale;
texture MeshTex;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_

// _VF[_
void ExplosionVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0, 
	out float4 Pos : POSITION, 
	out float4 Col : COLOR0,
	out float2 MeshUV : TEXCOORD0,
	out float2 PixelXY : TEXCOORD1
) {
	// _W
	float4 wvp_pos=mul(pos, WVProj);
	float4 wvp_normal=float4(mul(normal, (float3x3)WVProj), 0);
	Pos=wvp_pos+normalize(wvp_normal)*NormalScale*wvp_pos.w;
	
	// eNX`W
	MeshUV=mesh_uv;
	
	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)World));
	Col=max(0, dot(w_normal, -Light))*Diffuse+Ambient;
	Col.a=Diffuse.a;
	
	// sNZW
	PixelXY=Pos.xy*0.5f+0.5f;
}

// sNZVF[_
float4 ExplosionPS(
	float4 Col : COLOR, 
	float2 MeshUV : TEXCOORD0,
	float2 PixelXY : TEXCOORD1
) : COLOR {
	float4 color;
	float x=PixelXY.x*Width, y=PixelXY.y*Height;
	if (abs(x%PixelScale)<1.0f && abs(y%PixelScale)<1.0f) {
		color=tex2D(MeshSmp, MeshUV)*Col;
	} else {
		color=float4(0, 0, 0, 0);
	}
	return color;
}

//==============================================================
// eNjbN
technique Explosion {
	pass P0 {
		CullMode=NONE;
		VertexShader=compile vs_1_1 ExplosionVS();
		PixelShader=compile ps_2_0 ExplosionPS();
	}
}
