//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 LightWVPos;
float3 LightColor;
texture MeshTex;

float Power;
float Layer;
float Alpha;
float Density;
texture FurTex;
texture NormalTex;
#define PI 3.1415926536

#define TEX_SIZE 256

// eNX`ɑΉ邽߂̌W
// eNX`gpɂ͕sv
float IntScale;
float IntOffset;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler FurSmp=sampler_state {
	Texture=<FurTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler NormalSmp=sampler_state {
	Texture=<NormalTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_iV[j

// _VF[_
void SceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float3 Color : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 wv_pos=mul(pos, WView);
	float3 wv_normal=normalize(mul(normal, (float3x3)WView));
	Color=max(0, dot(wv_normal, normalize(LightWVPos-wv_pos)))*LightColor+Ambient;
}

// sNZVF[_
float4 ScenePS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*float4(Color, 1)*Diffuse;
}

//==============================================================
// VF[_it@[j

// _VF[_
void FurVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float2 MeshUV : TEXCOORD0,
	out float3 WVPos : TEXCOORD1,
	out float3 WVNormal : TEXCOORD2
) {
	// _W@ɂ炷
	pos+=Layer*float4(normal, 0);

	// _W̃[hr[ˉeϊ
	Pos=mul(pos, WVProj);
	
	// eNX`W
	MeshUV=mesh_uv;

	// [hr[ϊ_W
	WVPos=mul(pos, WView);
	WVNormal=normalize(mul(normal, (float3x3)WView));
}

// sNZVF[_
float4 FurPS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0,
	float3 WVPos : TEXCOORD1,
	float3 WVNormal : TEXCOORD2
) : COLOR {
	
	// @}bvϊs쐬
	float4 n=(tex2D(NormalSmp, MeshUV)-IntOffset)/IntScale;
	float a=n.x, b=n.y;
	float3x3 m={
		 0,  a,  a,
		-a,  0, -b,
		 b,  b,  0
	};

	// ϊsƒ_̖@t@[̖@vZ
	float3 wv_normal=mul(WVNormal, m);

	// CeBOi_j
	float3 lp=normalize(LightWVPos-WVPos);
	float hl=dot(lp, normalize(reflect(WVPos, wv_normal)));
	float4 color=
		Ambient+
		max(0, dot(wv_normal, lp))*Diffuse+
		pow(hl, Power)*Diffuse*2;
	return float4(color.rgb, Alpha)*tex2D(FurSmp, MeshUV);
}

// sNZVF[_i@}bvsgpj
float4 FurNoNormalMapPS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0,
	float3 WVPos : TEXCOORD1,
	float3 WVNormal : TEXCOORD2
) : COLOR {
	float3 wv_normal=WVNormal;

	// CeBOi_j
	float3 lp=normalize(LightWVPos-WVPos);
	float hl=dot(lp, normalize(reflect(WVPos, wv_normal)));
	float4 color=
		Ambient+
		max(0, dot(wv_normal, lp))*Diffuse;
	return float4(color.rgb, Alpha)*tex2D(FurSmp, MeshUV);
}

// sNZVF[_inCCgȂj
float4 FurNoSpecularPS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0,
	float3 WVPos : TEXCOORD1,
	float3 WVNormal : TEXCOORD2
) : COLOR {

	// @}bvϊs쐬
	float4 n=(tex2D(NormalSmp, MeshUV)-IntOffset)/IntScale;
	float a=n.x, b=n.y;
	float3x3 m={
		 0,  a,  a,
		-a,  0, -b,
		 b,  b,  0
	};

	// ϊsƒ_̖@t@[̖@vZ
	float3 wv_normal=mul(WVNormal, m);

	// CeBOi_j
	float3 lp=normalize(LightWVPos-WVPos);
	float hl=dot(lp, normalize(reflect(WVPos, wv_normal)));
	float4 color=
		Ambient+
		max(0, dot(wv_normal, lp))*Diffuse;
	return float4(color.rgb, Alpha)*tex2D(FurSmp, MeshUV);
}

//==============================================================
// VF[_it@[}bv̍쐬j
float4 MakeFurPS(
	float2 UV : TEXCOORD0
) : COLOR {
	float2 color=abs(sin(UV*PI/2*Density));
	return float4(1, 1, 1, color.x*color.y);
}

//==============================================================
// VF[_i@}bv̍쐬j
float4 MakeNormalPS(
	float2 UV : TEXCOORD0
) : COLOR {
	
	// ł߂т̒S_̃xNg
	float2 ab=frac(UV*Density)-0.5f;

	// K
	float d=distance(ab.x, ab.y);
	if (d>0) ab/=d; else ab=0;
	return float4(ab.x, ab.y, 0, 0)*IntScale+IntOffset;
}

// @}bv̕\
float4 ShowNormalPS(
	float2 UV : TEXCOORD0
) : COLOR {
	float2 rg=(tex2D(NormalSmp, UV).rg-IntOffset)/IntScale+0.5f;
	return float4(rg.x, rg.y, 0, 1);
}

//==============================================================
// eNjbN

technique Scene {
	pass P0 {
		VertexShader=compile vs_1_1 SceneVS();
		PixelShader=compile ps_1_1 ScenePS();
	}
}

technique Fur {
	pass P0 {
		VertexShader=compile vs_1_1 FurVS();
		PixelShader=compile ps_2_0 FurPS();
		CullMode=CW;
	}
	pass P1 {
		CullMode=CCW;
	}
}

technique FurNoNormalMap {
	pass P0 {
		VertexShader=compile vs_1_1 FurVS();
		PixelShader=compile ps_2_0 FurNoNormalMapPS();
		CullMode=CW;
	}
	pass P1 {
		CullMode=CCW;
	}
}

technique FurNoSpecular {
	pass P0 {
		VertexShader=compile vs_1_1 FurVS();
		PixelShader=compile ps_2_0 FurNoSpecularPS();
		CullMode=CW;
	}
	pass P1 {
		VertexShader=compile vs_1_1 FurVS();
		PixelShader=compile ps_2_0 FurNoSpecularPS();
		CullMode=CCW;
	}
}

technique FurNoCullMode {
	pass P0 {
		VertexShader=compile vs_1_1 FurVS();
		PixelShader=compile ps_2_0 FurPS();
	}
}

technique MakeFur {
	pass P0 {
		PixelShader=compile ps_2_0 MakeFurPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}

technique MakeNormal {
	pass P0 {
		PixelShader=compile ps_2_0 MakeNormalPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}

technique ShowNormal {
	pass P0 {
		PixelShader=compile ps_2_0 ShowNormalPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}
