//==============================================================
// 萔
float4x4 WVProj;
texture EnvTex;
float NormalScale;

//==============================================================
// eNX`Tv
sampler EnvSmp=sampler_state {
	Texture=<EnvTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
	AddressV=CLAMP;
};

//==============================================================
// VF[_

// _VF[_
void StealthVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	out float4 Pos : POSITION,
	out float2 EnvUV : TEXCOORD0
) {
	// _W
	Pos=mul(pos, WVProj);
	
	// eNX`W
	float3 wvp_normal=normalize(mul(normal, (float3x3)WVProj));
	EnvUV=
		(Pos.xy+wvp_normal.xy*NormalScale)/Pos.w
		*float2(0.5f, -0.5f)+0.5f;
}

// sNZVF[_
float4 StealthPS(
	float2 EnvUV : TEXCOORD0
) : COLOR {
	return tex2D(EnvSmp, EnvUV);
}

//==============================================================
// eNjbN
technique Stealth {
	pass P0 {
		VertexShader=compile vs_1_1 StealthVS();
		PixelShader=compile ps_1_1 StealthPS();
	}
}
