//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float3 Ambient;
float3 LightDir;
float3 LightColor;
texture MeshTex;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};

//==============================================================
// VF[_

// _VF[_
void TimePassageVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float3 Color : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)World));
	Color=max(0, dot(w_normal, -LightDir))*LightColor+Ambient;
}

// sNZVF[_
float4 TimePassagePS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*float4(Color, 1)*Diffuse;
}

//==============================================================
// eNjbN
technique TimePassage {
	pass P0 {
		VertexShader=compile vs_1_1 TimePassageVS();
		PixelShader=compile ps_1_1 TimePassagePS();
	}
}
