//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 LightWVPos;
float3 LightColor;
texture MeshTex;
texture HeightTex;
texture NormalTex;

float Spring;
float4 WaveDiffuse;
float3 WaveSpecular;
float WavePower;

float4 AddWavePos;
float AddWaveRad;
float AddWaveVelocity;

#define TEX_SIZE 256

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler HeightSmp=sampler_state {
	Texture=<HeightTex>;
	MipFilter=POINT;
	MinFilter=POINT;
	MagFilter=POINT;
};
sampler NormalSmp=sampler_state {
	Texture=<NormalTex>;
/*
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
*/
	// eNX`̐`ԂłȂւ̑Ή
	MipFilter=POINT;
	MinFilter=POINT;
	MagFilter=POINT;
};

//==============================================================
// VF[_iV[j

// _VF[_
void SceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float3 Color : COLOR0,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;

	// _F
	float3 wv_pos=mul(pos, WView);
	float3 wv_normal=normalize(mul(normal, (float3x3)WView));
	Color=max(0, dot(wv_normal, normalize(LightWVPos-wv_pos)))*LightColor+Ambient;
}

// sNZVF[_
float4 ScenePS(
	float3 Color : COLOR0,
	float2 MeshUV : TEXCOORD0
) : COLOR {

	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, MeshUV)*float4(Color, 1)*Diffuse;
}

//==============================================================
// VF[_igj

// _VF[_
void WaveVS (
	float4 pos : POSITION,
	float2 normal_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float2 NormalUV : TEXCOORD0,
	out float3 WVPos : TEXCOORD1
) {
	// _WƃeNX`W
	Pos=mul(pos, WVProj);
	NormalUV=normal_uv;
	
	// [hr[ϊ_W
	WVPos=mul(pos, WView);
}

// sNZVF[_
float4 WavePS(
	float2 NormalUV : TEXCOORD0,
	float3 WVPos : TEXCOORD1
) : COLOR 
{
	// eNX`̐`ԂłȂւ̑Ή
	float4 
		t0=tex2D(NormalSmp, NormalUV),
		t1=tex2D(NormalSmp, NormalUV+float2(1.0f/TEX_SIZE, 0)),
		t2=tex2D(NormalSmp, NormalUV+float2(0, 1.0f/TEX_SIZE)),
		t3=tex2D(NormalSmp, NormalUV+float2(1.0f/TEX_SIZE, 1.0f/TEX_SIZE));
	float2 f=frac(NormalUV*TEX_SIZE);
	float4 t=lerp(lerp(t0, t1, f.x), lerp(t2, t3, f.x), f.y);

	// @̌vZ
//	float4 t=tex2D(NormalSmp, NormalUV);
	float3 normal=normalize(cross(float3(0, t.g, 1), float3(1, t.r, 0)));
	
	// CeBOi_j
	float3 lp=normalize(LightWVPos-WVPos);
	float3 wv_normal=normalize(mul(normal, (float3x3)WView));
	float hl=dot(lp, normalize(reflect(WVPos, wv_normal)));
	float3 color=
		Ambient+
		max(0, dot(wv_normal, lp))*WaveDiffuse+
		pow(hl, WavePower)*WaveSpecular;

	// sNZF̏o
	return float4(color*LightColor, WaveDiffuse.a);
}

//==============================================================
// VF[_ix}bvj
float4 HeightPS(
	float2 HeightUV : TEXCOORD0
) : COLOR
{
	// S_Ɨאڂ4_TvO
	float4 
		t0=tex2D(HeightSmp, HeightUV),
		t1=tex2D(HeightSmp, HeightUV+float2(-1.0f/TEX_SIZE, 0)),
		t2=tex2D(HeightSmp, HeightUV+float2( 1.0f/TEX_SIZE, 0)),
		t3=tex2D(HeightSmp, HeightUV+float2(0, -1.0f/TEX_SIZE)),
		t4=tex2D(HeightSmp, HeightUV+float2(0,  1.0f/TEX_SIZE));

	// x̌vZ
	float velocity=t0.g+Spring*(t1.r+t2.r+t3.r+t4.r-t0.r*4);
	
	// ʒǔvZ
	float height=t0.r+velocity;
	
	// g̒ǉ
	if (distance(AddWavePos, HeightUV)<=AddWaveRad) velocity+=AddWaveVelocity;

	// VʒuƑx̏o
	return float4(height, velocity, 0, 0);
}

//==============================================================
// VF[_i@}bvj
float4 NormalPS(
	float2 HeightUV : TEXCOORD0
) : COLOR
{
	// S_ɗאڂ4_TvO
	float4 
		t1=tex2D(HeightSmp, HeightUV+float2(-1.0f/TEX_SIZE, 0)),
		t2=tex2D(HeightSmp, HeightUV+float2( 1.0f/TEX_SIZE, 0)),
		t3=tex2D(HeightSmp, HeightUV+float2(0, -1.0f/TEX_SIZE)),
		t4=tex2D(HeightSmp, HeightUV+float2(0,  1.0f/TEX_SIZE));

	// XvZďo
	return float4((t2.r-t1.r)*0.5f, (t4.r-t3.r)*0.5f, 0, 0);
}

//==============================================================
// xƑx̕\
float4 ShowHeightPS(
	float2 HeightUV : TEXCOORD0
) : COLOR
{
	float t=tex2D(HeightSmp, HeightUV).r*0.01f+0.5f;
	return float4(t, t, t, 1);
}
float4 ShowVelocityPS(
	float2 HeightUV : TEXCOORD0
) : COLOR
{
	float t=tex2D(HeightSmp, HeightUV).g+0.5f;
	return float4(t, t, t, 1);
}

//==============================================================
// eNjbN
technique Scene {
	pass P0 {
		VertexShader=compile vs_1_1 SceneVS();
		PixelShader=compile ps_1_1 ScenePS();
	}
}
technique Wave {
	pass P0 {
		VertexShader=compile vs_1_1 WaveVS();
		PixelShader=compile ps_2_0 WavePS();
	}
}
technique Height {
	pass P0 {
		PixelShader=compile ps_2_0 HeightPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}
technique Normal {
	pass P0 {
		PixelShader=compile ps_2_0 NormalPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}
technique ShowHeight {
	pass P0 {
		PixelShader=compile ps_2_0 ShowHeightPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}
technique ShowVelocity {
	pass P0 {
		PixelShader=compile ps_2_0 ShowVelocityPS();
		ZEnable=FALSE;
		ZWriteEnable=FALSE;
	}
}
