#include "Main.h"
#include "Explosion.h"


//==============================================================
// 

// RXgN^
CExplosion::CExplosion(
	CMain* main, string title, int mode
)
:	CDemo(main, title), Yaw(0), Scale(0), Time(0), Mode(mode)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneHorror_Obj.x");
	MeshEnv=LoadMesh("SceneHorror_Env.x");

	// GtFNg̃[h
	Effect=LoadEffect("Explosion.fx");
}

// fXgN^
CExplosion::~CExplosion() {
}
	
// ړ
void CExplosion::Move() {

	// ̂̉]
	Yaw+=0.01f;
	
	// ̊gƏk
	Scale=pow(sin(Time/50.0f), 2)*3.0f;
	Time++;
}

// `
void CExplosion::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 5, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// wi̕`
	Graphics->Clear(BGColor);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshEnv->Draw();

	//==========================================================
	// GtFNgKpĕ̂`

	// [hs
	Device->SetTransform(D3DTS_WORLD, &world);
	Effect->SetMatrix("World", &world);

	// [hr[ˉes
	D3DXMATRIX wv_proj;
	D3DXMatrixMultiply(&wv_proj, &world, &view);
	D3DXMatrixMultiply(&wv_proj, &wv_proj, &proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	D3DXVECTOR4 light(1, -1, 1, 0);
	D3DXVec4Normalize(&light, &light);
	Effect->SetVector("Light", &light);
	
	// 
	Effect->SetVector("Ambient", (D3DXVECTOR4*)&ambient);

	// p[^
	Effect->SetFloat("NormalScale", Scale);
	if (Mode==0) {
		Effect->SetFloat("PixelScale", Scale*5.0f);
	} else {
		Effect->SetFloat("PixelScale", 1.0f);
	}
	Effect->SetFloat("Width", w);
	Effect->SetFloat("Height", w);

	// eNjbN
	Effect->SetTechnique("Explosion");

	// `
	DrawMesh(MeshObj, Effect);
}

