#include "Main.h"
#include "Fur.h"

#define TEX_SIZE 256
LPDIRECT3DTEXTURE9 CFur::FurTexture=NULL;
LPDIRECT3DTEXTURE9 CFur::NormalTexture=NULL;
bool CFur::UseIntTexture=false;

// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }


//==============================================================
// t@[

// RXgN^
CFur::CFur(
	CMain* main, string title, int mode, 
	int layer_count, float vyaw, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	D3DXVECTOR3 lpos, D3DXVECTOR3 lcol
)
:	CDemo(main, title), Mode(mode), 
	LayerCount(layer_count), Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat), 
	LightWVPos(D3DXVECTOR4(lpos, 1)), 
	LightColor(D3DXVECTOR4(lcol, 1))
{
	// bṼ[h
	Mesh=LoadMesh("SceneBarbar.x");
	for (int i=0; i<FUR_COUNT; i++) {
		MeshFur[i]=LoadMesh("SceneBarbar_Fur"+ToStr(i)+".x");
	}
	
	// GtFNg̃[h
	Effect=LoadEffect("Fur.fx");
}

// foCXZbg
void CFur::OnResetDevice() {
	CDemo::OnResetDevice();

	// t@[}bv̍쐬
	if (!FurTexture) {
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
			D3DPOOL_DEFAULT, &FurTexture, NULL);
		
		// t@[}bv̕`
		if (FurTexture) {
			Graphics->BeginScene();
			SetRenderTarget(FurTexture, NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
			Effect->SetTechnique("MakeFur");
			Effect->SetFloat("Density", 300);
			DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
			Graphics->EndScene();
		}
	}

	// @}bv̍쐬
	if (!NormalTexture) {
		
		// eNX`
		UseIntTexture=false;
		Device->CreateTexture(
			TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16F, 
			D3DPOOL_DEFAULT, &NormalTexture, NULL);

		// eNX`
		if (!NormalTexture) {
			UseIntTexture=true;
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_G16R16, 
				D3DPOOL_DEFAULT, &NormalTexture, NULL);
		}
		if (!NormalTexture) {
			UseIntTexture=true;
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A16B16G16R16, 
				D3DPOOL_DEFAULT, &NormalTexture, NULL);
		}
		if (!NormalTexture) {
			UseIntTexture=true;
			Device->CreateTexture(
				TEX_SIZE, TEX_SIZE, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, 
				D3DPOOL_DEFAULT, &NormalTexture, NULL);
		}

		// @}bv̕`
		if (NormalTexture) {
			Graphics->BeginScene();
			SetRenderTarget(NormalTexture, NULL);
			Device->Clear(0, NULL, D3DCLEAR_TARGET, 0, 1, 0);
			Effect->SetTechnique("MakeNormal");
			Effect->SetFloat("IntScale", UseIntTexture?0.5f:1.0f);
			Effect->SetFloat("IntOffset", UseIntTexture?0.5f:0.0f);
			DrawRect(Effect, 0, 0, TEX_SIZE, TEX_SIZE, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
			Graphics->EndScene();
		}
	}	
}

// foCXXg
void CFur::OnLostDevice() {
	CDemo::OnLostDevice();
	SAFE_RELEASE(FurTexture);
}

// fXgN^
CFur::~CFur() {
	OnLostDevice();
}
	
// ړ
void CFur::Move() {
	Yaw+=VYaw;
}

// t@[sŃ\[g邽߂̍\
struct FUR {
	CMesh* Mesh;
	D3DXVECTOR4 Pos;
};

// t@[sŃ\[g邽߂̔r֐
int CompareFurZ(const void* a, const void* b) {
	float diff=((FUR*)b)->Pos.z-((FUR*)a)->Pos.z;
	return ceil(diff)+floor(diff);
}

// `
void CFur::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!Mesh) { Error="Mesh"; return; }
	for (int i=0; i<FUR_COUNT; i++) {
		if (!MeshFur[i]) { Error=string("MeshFur")+ToStr(i); return; }
	}	
	if (!Effect) { Error="Effect"; return; }
	if (!FurTexture) { Error="FurTexture"; return; }
	if (!NormalTexture) { Error="NormalTexture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &From, &Lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	Effect->SetMatrix("Proj", &wv_proj);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	Effect->SetVector("LightWVPos", &LightWVPos);
	Effect->SetVector("LightColor", &LightColor);

	// 
	Effect->SetVector("Ambient", &D3DXVECTOR4(0.2f, 0.2f, 0.2f, 1));

	// V[̕`
	ResetRenderTarget();
	Graphics->Clear(BGColor);
	Effect->SetTechnique("Scene");
	DrawMesh(Mesh, Effect);

	// t@[sŃ\[g
	FUR fur[]={
		{MeshFur[0], D3DXVECTOR4(0, 1, 0, 1)},
		{MeshFur[1], D3DXVECTOR4(2.5f, 1, 0, 1)}
	};
	for (int i=0; i<FUR_COUNT; i++) {
		D3DXVec4Transform(&fur[i].Pos, &fur[i].Pos, &w_view);
	}
	if (Mode!=FUR_NOSORT) {
		qsort(fur, FUR_COUNT, sizeof(FUR), CompareFurZ);
	}

	// t@[̕`
	Effect->SetTechnique("Fur");
	Effect->SetTexture("FurTex", FurTexture);
	Effect->SetTexture("NormalTex", NormalTexture);
	Effect->SetFloat("Power", 2);
	Effect->SetFloat("IntScale", UseIntTexture?0.5f:1.0f);
	Effect->SetFloat("IntOffset", UseIntTexture?0.5f:0.0f);
	
	if (Mode==FUR_NOFUR) {
		Effect->SetTechnique("FurNoNormalMap");
		Effect->SetTexture("FurTex", Main->GetDummyTexture());
	}
	if (Mode==FUR_NONORMAL) {
		Effect->SetTechnique("FurNoNormalMap");
	}
	if (Mode==FUR_NOSPECULAR) {
		Effect->SetTechnique("FurNoSpecular");
	}
	if (Mode==FUR_NOCULLMODE) {
		Effect->SetTechnique("FurNoCullMode");
	}
	
	for (int i=0; i<FUR_COUNT; i++) {
		for (int layer=0; layer<LayerCount; layer++) {
			Effect->SetFloat("Layer", layer*0.02f);
			Effect->SetFloat("Alpha", 1.0f*(LayerCount-layer)/LayerCount);
			DrawMesh(fur[i].Mesh, Effect);
		}
	}

	if (Mode==FUR_FURMAP) {	
		Graphics->Clear();
		DrawTexture(FurTexture, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==FUR_NORMALMAP) {
		Effect->SetTechnique("ShowNormal");
		DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
	}
	if (Mode==FUR_FURMESH) {
		Graphics->Clear(BGColor);
		Effect->SetTechnique("Scene");
		DrawMesh(MeshFur[0], Effect);
		DrawMesh(MeshFur[1], Effect);
	}
}

