#include "Main.h"
#include "Ice.h"

// RXgN^
CIce::CIce(
	CMain* main, string title, int mode, 
	float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), Mode(mode), 
	Yaw(0), VYaw(vyaw), 
	From(from), Lookat(lookat), 
	Time(0), IceRadius(0)
{
	// bṼ[h
	MeshScene=LoadMesh("ScenePool.x");
	MeshIce=LoadMesh("ScenePool_Shadow.x");

	// GtFNg̃[h
	Effect=LoadEffect("Ice.fx");
}

// fXgN^
CIce::~CIce() {
}
	
// ړ
void CIce::Move() {

	// V[̉]
	Yaw+=VYaw;
	
	// ԂƓ͈͂̍XV
	Time++;
	IceRadius=pow(sin(Time*0.01f), 2)*10;
}

// `
void CIce::Draw() {

	// G[`FbN
	if (!PS20()) { Error="PS2.0"; return; }
	if (!MeshScene) { Error="MeshScene"; return; }
	if (!MeshIce) { Error="MeshIce"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &From, &Lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	Effect->SetVector("LightWVPos", &D3DXVECTOR4(0, 2.5f, 0, 1));
	Effect->SetVector("LightColor", &D3DXVECTOR4(0.3f, 0.3f, 0.8f, 0));

	// 
	Effect->SetVector("Ambient", &D3DXVECTOR4(0.2f, 0.2f, 0.2f, 1));

	// V[̕`
	ResetRenderTarget();
	Effect->SetTechnique("Scene");
	Graphics->Clear(BGColor);
	DrawMesh(MeshScene, Effect);

	// X̕`
	Effect->SetFloat("IceRadius", IceRadius);
	Effect->SetVector("IceCenter", &D3DXVECTOR4(0, 0, 0, 1));
	Effect->SetFloat("IceScale", 0.1f);
	Effect->SetVector("IceDiffuse", &D3DXVECTOR4(0.4f, 0.4f, 0.8f, 0.6f));
	Effect->SetVector("IceSpecular", &D3DXVECTOR4(2.0f, 2.0f, 2.4f, 1));
	Effect->SetFloat("IcePower", 2);
	if (Mode!=ICE_NOADDBLEND) {
		Effect->SetTechnique("Ice");
	} else {
		Effect->SetTechnique("IceNoAddBlend");
	}
	DrawMesh(MeshIce, Effect);
}

