#include "Main.h"
#include "Leaf.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }


//==============================================================
// t

// RXgN^
CEachLeaf::CEachLeaf(
	vector<CMesh*> mesh, 
	float min_vy, float max_vy, 
	float max_xz, float max_y, 
	float max_vxz, float max_axz, 
	float min_size, float max_size,
	float dir_scale, float vdir_scale
) 
:	Mesh(mesh), 
	MinVY(min_vy), MaxVY(max_vy), 
	MaxXZ(max_xz), MaxY(max_y), 
	MaxVXZ(max_vxz), MaxAXZ(max_axz), 
	MinSize(min_size), MaxSize(max_size), 
	DirScale(dir_scale), VDirScale(vdir_scale)
{
	// WAAxATCYAgpbVԍ̐ݒ
	Init();
}

// 
void CEachLeaf::Init() {

	// WAx
	Pos=D3DXVECTOR3(Rand05()*MaxXZ, Rand1()*MaxY, Rand05()*MaxXZ);
	VPos=D3DXVECTOR3(Rand05()*MaxVXZ, MinVY+(MaxVY-MinVY)*Rand1(), Rand05()*MaxVXZ);

	// ]A]x
	Dir=D3DXVECTOR3(Rand1(), Rand1(), Rand1())*D3DX_PI*2*DirScale;
	VDir=D3DXVECTOR3(Rand05(), Rand05(), Rand05())*VDirScale;

	// TCYAbVԍ
	Size=MinSize+(MaxSize-MinSize)*Rand1();
	MeshIndex=Rand.Int32()%Mesh.size();
}

// ړ
void CEachLeaf::Move() {

	// A]A̗h
	Pos+=VPos;
	Dir+=VDir;
	VPos.x+=Rand05()*MaxAXZ;
	VPos.z+=Rand05()*MaxAXZ;

	// nʂɗWAxATCYAgpbVԍĐݒ
	if (Pos.y<0) {
		Init();
		Pos.y=MaxY;
	}
}

// `
void CEachLeaf::Draw(
	LPDIRECT3DDEVICE9 device, const D3DXMATRIX* world
) {
	// [hs̐ݒ
	D3DXMATRIX m0, m1, m2;
	D3DXMatrixScaling(&m0, Size, Size, Size);
	D3DXMatrixRotationYawPitchRoll(&m1, Dir.x, Dir.y, Dir.z);
	D3DXMatrixTranslation(&m2, Pos.x, Pos.y, Pos.z);

	D3DXMatrixMultiply(&m0, &m0, &m1);
	D3DXMatrixMultiply(&m0, &m0, &m2);
	D3DXMatrixMultiply(&m0, &m0, world);
	device->SetTransform(D3DTS_WORLD, &m0);

	// bV̕`
	Mesh[MeshIndex]->Draw(sin(D3DX_PI*(MaxY-Pos.y)/MaxY)); 
}


//==============================================================
// t̃f

// RXgN^
CLeaf::CLeaf(
	CMain* main, string title, 
	string mesh_scene, string mesh_leaf, 
	int leaf_count, 
	float min_size, float max_size, 
	float max_vxz, float max_axz, 
	float dir_scale, float vdir_scale, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	float vyaw, 
	D3DXVECTOR3 light_dir, D3DXCOLOR light_color
)
:	CDemo(main, title), Yaw(0), VYaw(vyaw),
	LeafCount(leaf_count), 
	MaxVXZ(max_vxz), MaxAXZ(max_axz), 
	MinSize(min_size), MaxSize(max_size), 
	DirScale(dir_scale), VDirScale(vdir_scale), 
	From(from), Lookat(lookat),
	LightDir(light_dir), LightColor(light_color)
{
	// bṼ[h
	MeshScene=LoadMesh(mesh_scene);
	for (int i=0; ; i++) {
		CMesh* mesh=LoadMesh(mesh_leaf+ToStr(i)+".x");
		if (!mesh) break;
		MeshLeaf.push_back(mesh);
	}

	// t̍쐬
	Leaf=new CEachLeaf*[LeafCount];
	for (int i=0; i<LeafCount; i++) {
		Leaf[i]=new CEachLeaf(
			MeshLeaf, -0.01f, -0.02f, 
			10, 5, MaxVXZ, MaxAXZ, MinSize, MaxSize, DirScale, VDirScale);
	}
}

// fXgN^
CLeaf::~CLeaf() {
	for (int i=0; i<LeafCount; i++) delete Leaf[i];
	delete[] Leaf;
}
	
// ړ
void CLeaf::Move() {

	// V[̉]
	Yaw+=VYaw;

	// t𓮂
	for (int i=0; i<LeafCount; i++) Leaf[i]->Move();
}

// `
void CLeaf::Draw() {

	// G[`FbN
	if (!MeshScene) { Error="MeshScene"; return; }
	for (int i=0; i<(int)MeshLeaf.size(); i++) {
		if (!MeshLeaf[i]) { Error="MeshLeaf"+ToStr(i); return; }
	}

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, D3DXVECTOR3(0, 0, 0), 
		LightDir, LightColor, 1000);

	// 
	D3DXCOLOR ambient(0.4f, 0.4f, 0.4f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	MeshScene->Draw();

	// t̕`
	for (int i=0; i<LeafCount; i++) Leaf[i]->Draw(Device, &world);
}

