#include "Main.h"
#include "LensFlare.h"


//==============================================================
// YtA

// RXgN^
CLensFlare::CLensFlare(CMain* main, string title)
:	CDemo(main, title), Yaw(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneCactus.x");

	// eNX`̃[h
	LightTexture=LoadTexture("LensFlareLight.png");
	for (int i=0; i<FLARE_TEXTURE_COUNT; i++) {
		FlareTexture[i]=LoadTexture("LensFlare"+ToStr(i)+".png");
	}
}

// fXgN^
CLensFlare::~CLensFlare() {
}
	
// ړ
void CLensFlare::Move() {
	Yaw+=0.01f;
}

// `
void CLensFlare::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!LightTexture) { Error="LightTexture"; return; }
	for (int i=0; i<FLARE_TEXTURE_COUNT; i++) {
		if (!FlareTexture[i]) { Error="FlareTexture"+ToStr(i); return; }
	}

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 1, -8);
	D3DXVECTOR3 lookat(0, 2, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// Cg
	D3DXVECTOR3 light(1, -0.5f, -1);
	D3DXVECTOR4 w_light;
	D3DXVec3Transform(&w_light, &light, &world);
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, w_light.x, w_light.y, w_light.z, 1000);

	// ʂ̃NA
	Graphics->Clear(BGColor);

	// Cg̈ʒu
	D3DXVECTOR4 wvp_light(-light*500, 1);
	D3DXVec4Transform(&wvp_light, &wvp_light, &world);
	D3DXVec4Transform(&wvp_light, &wvp_light, &view);
	D3DXVec4Transform(&wvp_light, &wvp_light, &proj);
	float 
		lx= wvp_light.x/wvp_light.w,
		ly=-wvp_light.y/wvp_light.w, 
		lz= wvp_light.z/wvp_light.w;

	// Cgizj̕`
	if (abs(lx)<1 && abs(ly)<1 && lz>0) {
		float x=(lx+1)*w*0.5f, y=(ly+1)*h*0.5f, s=w*0.03f;
		DrawTexture(
			LightTexture, 
			x-s, y-s, x+s, y+s, 0, 0, 1, 1, 
			D3DXCOLOR(1, 1, 1, 1));
	}

	// V[̕`
	Mesh->Draw();

	// YtA̕`
	if (abs(lx)<1 && abs(ly)<1 && lz>0) {

		// Z
		Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

		// YtÃf[^
		struct FLARE {
			int TextureIndex;
			float Pos, Size, Alpha;
		};
		static FLARE flare[]={
			{0, 0.1f, 0.1f, 0.3f}, 
			{1, 0.2f, 0.2f, 0.4f}, 
			{2, 0.3f, 0.3f, 0.5f}, 
			{3, 0.4f, 0.2f, 0.4f},
			{0, 0.5f, 0.1f, 0.3f}, 
			{3, 0.6f, 0.2f, 0.4f}, 
			{2, 0.7f, 0.3f, 0.5f}, 
			{1, 0.8f, 0.2f, 0.4f},
			{0, 0.9f, 0.1f, 0.3f}
		};

		// YtApeNX`̕`
		for (int i=0; i<sizeof(flare)/sizeof(FLARE); i++) {
			float
				x=(lx*(1-flare[i].Pos*2)+1)*w*0.5f,
				y=(ly*(1-flare[i].Pos*2)+1)*h*0.5f,
				dist=sqrt(lx*lx+ly*ly)/sqrt(2.0f),
				s=dist*flare[i].Size*w*0.5f,
				alpha=(1-dist)*flare[i].Alpha*1.5f;
			DrawTexture(
				FlareTexture[flare[i].TextureIndex], 
				x-s, y-s, x+s, y+s, 0, 0, 1, 1, 
				D3DXCOLOR(1, 1, 1, alpha));
		}

		// ʏ퍇
		Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	}
}

