#include "Main.h"
#include "LightTrail.h"


//==============================================================
// 

// RXgN^
CLightTrail::CLightTrail(CMain* main, string title, int mode, float alpha, float scale, float roll)
:	CDemo(main, title), Mode(mode), 
	Target(0), ObjYaw(0), EnvYaw(0), Alpha(alpha), 
	Roll(roll), Scale(scale)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneTrain_ObjLight.x");
	MeshEnv=LoadMesh("SceneTrain_Env.x");
}

// fXgN^
CLightTrail::~CLightTrail() {
}
	
// ړ
void CLightTrail::Move() {
	ObjYaw-=0.05f;
	EnvYaw-=0.01f;
	Target=1-Target;
}

// `
void CLightTrail::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 5, -9);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// ʂ̃NA
	Graphics->Clear(BGColor);

	// wi̕`
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, EnvYaw);
	Device->SetTransform(D3DTS_WORLD, &world);	
	MeshEnv->Draw();

	// ʂɔ񔭌`悷
	D3DXMatrixRotationY(&world, ObjYaw);
	Device->SetTransform(D3DTS_WORLD, &world);	
	for (DWORD i=0, n=MeshObj->GetNumMaterials(); i<n; i++) {
		D3DMATERIAL9* mat=MeshObj->GetMaterial(i);
		if (mat->Emissive.r+mat->Emissive.g+mat->Emissive.b==0) {
			Device->SetMaterial(mat);
			Device->SetTexture(0, MeshObj->GetTexture(i));
			MeshObj->DrawSubset(i);
		}
	}

	// eNX`0ɔ`悷
	SetRenderTarget(WorkTexture[Target], OrgDepthStencil);

	if (Mode==0) {
		Device->Clear(
			0, NULL, D3DCLEAR_TARGET,
			D3DXCOLOR(0, 0, 0, 1), 1.0f, 0);
	} else {
		Device->Clear(
			0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
			D3DXCOLOR(0, 0, 0, 1), 1.0f, 0);	
	}

	for (DWORD i=0, n=MeshObj->GetNumMaterials(); i<n; i++) {
		D3DMATERIAL9* mat=MeshObj->GetMaterial(i);
		if (mat->Emissive.r+mat->Emissive.g+mat->Emissive.b>0) {
			Device->SetMaterial(mat);
			Device->SetTexture(0, MeshObj->GetTexture(i));
			MeshObj->DrawSubset(i);
		}
	}

	// _O̐ݒ
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	// eNX`0ɑOt[̔
	DrawTexture(WorkTexture[1-Target], 
		0, 0, w-1, h-1, 
		0, 0, 1, 1, D3DCOLOR_ARGB((int)(255*Alpha), 255, 255, 255));

	// eNX`0ʂɍ
	ResetRenderTarget();
	DrawTexture(WorkTexture[Target], 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));

	// _O̕A
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
}
