#include "Main.h"
#include "Toon.h"
#include "YIQ.h"
#include "Noise.h"
#include "Mosaic.h"
#include "Raster.h"
#include "Spiral.h"
#include "Stealth.h"
#include "Reflection.h"
#include "Blur.h"
#include "LightTrail.h"
#include "LiveMonitor.h"
#include "Scanline.h"
#include "DepthOfField.h"
#include "MovieFilm.h"
#include "TireTrack.h"
#include "Footmark.h"
#include "FocusLine.h"
#include "Explosion.h"
#include "FadeInOut.h"
#include "ColorInOut.h"
#include "CutIn.h"
#include "Peephole.h"
#include "Basic.h"
#include "ShadowVolume.h"
#include "LensFlare.h"
#include "HDR.h"
#include "ShadowMap.h"
#include "TimePassage.h"
#include "Snow.h"
#include "Leaf.h"
#include "Rain.h"
#include "Wave.h"
#include "Fur.h"
#include "Spark.h"
#include "Smoke.h"
#include "Fire.h"
#include "Blood.h"
#include "MagicCircle.h"
#include "Ice.h"
#include "VolumeFog.h"
#include "CoverFire.h"
#include "CoverMonitor.h"
#include "CoverTakibi.h"
#include "CoverWave.h"


// eNX`hԂp̊֐
static VOID WINAPI FillTexture(
	D3DXVECTOR4* pOut, const D3DXVECTOR2* pTexCoord, 
	const D3DXVECTOR2* pTexelSize, LPVOID pData
) {
	*pOut=*(D3DXVECTOR4*)pData;
}

// [NeNX`̐
int CMain::GetWorkCount() {
	return 4;
}

// R}hCIvV
static bool ArgExist(string option) {
	for (int i=1; i<__argc; i++) {
		if (__argv[i]==option) return true;
	}
	return false;
}

//==============================================================
// RXgN^
CMain::CMain()
:	CGame("ЁwQ[GtFNg}jAbNXxiYY^i䂫jTvvO", true, false, false), 
	RandSeed(1), CurrentDemo(0), PrevInput(false), PrevDemo(-1)
{
	// wvAIAJ[\Ɋւݒ
	HelpURL="http://cgi32.plala.or.jp/higpen/gate.shtml";
	ConfirmExit=false;

	// tHg̏
	ImageGroup=new CImageGroup(Graphics->GetDevice(), 800, 600);
	string path=ExePath+"..\\Font\\";
	static const char fontchar[]=
		"~|0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		",.(){}<>!?+-~*/='\\\"#$%&@[]"
		"abcdefghijklmnopqrstuvwxyz";
	Font=new CFont(ImageGroup);
	Font->LoadFromFile(path+"font.png", NULL, fontchar, 16, 32, 16, 32, 2, 2);

	// OtBbN
	Graphics->SetDepthStencilFormat(D3DFMT_D24S8);
	Graphics->ResetDevice();

	// _O^[Qbg̃eNX`Ɛ[xobt@
	WorkTexture=new LPDIRECT3DTEXTURE9[GetWorkCount()];
	WorkDepthStencil=new LPDIRECT3DSURFACE9[GetWorkCount()];

	//==============================================================
	// ƉẽGtFNg
	if (ArgExist("1") || ArgExist("light") || ArgExist("all")) {
		Demo.push_back(new CBasic(this, "BASIC"));
		Demo.push_back(new CToon(this, "TOON(PAINT+INK)", "ToonPaint.png", "ToonPaintInk", D3DXCOLOR(0, 0, 0, 1), 0.007f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(PAINT ONLY)", "ToonPaint.png", "ToonMixed", D3DXCOLOR(0, 0, 0, 1), 0.007f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(INK ONLY)", "ToonGradation.png", "ToonPaintInk", D3DXCOLOR(0.2f, 0.2f, 0.2f, 1), 0.007f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(GRADATION)", "ToonGradation.png", "ToonMixed", D3DXCOLOR(0.2f, 0.2f, 0.2f, 1), 0.007f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(PAINT+INK, THIN)", "ToonPaint.png", "ToonPaintInk", D3DXCOLOR(0, 0, 0, 1), 0.003f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(PAINT+INK, THICK)", "ToonPaint.png", "ToonPaintInk", D3DXCOLOR(0, 0, 0, 1), 0.014f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CToon(this, "TOON(PAINT+INK, WHITE)", "ToonPaint.png", "ToonPaintInk", D3DXCOLOR(0, 0, 0, 1), 0.007f, D3DXCOLOR(1, 1, 1, 1)));
		Demo.push_back(new CToon(this, "TOON(PAINT+INK, BROWN)", "ToonPaint.png", "ToonPaintInk", D3DXCOLOR(0, 0, 0, 1), 0.007f, D3DXCOLOR(0.7f, 0.4f, 0.1f, 1)));
		Demo.push_back(new CToon(this, "TOON(MIXED)", "ToonMixed.png", "ToonMixed", D3DXCOLOR(0, 0, 0, 1), 0.007f, D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CReflection(this, "REFLECTION(0.00)", 0.00f));
		Demo.push_back(new CReflection(this, "REFLECTION(0.25)", 0.25f));
		Demo.push_back(new CReflection(this, "REFLECTION(0.50)", 0.50f));
		Demo.push_back(new CReflection(this, "REFLECTION(0.75)", 0.75f));
		Demo.push_back(new CReflection(this, "REFLECTION(1.00)", 1.00f));
		Demo.push_back(new CLensFlare(this, "LENS FLARE"));
		Demo.push_back(new CHDR(this, "HDR(SCENE1)", 1, 1.00f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE)", 1, 0.05f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE+BLOOM)", 0, 0.05f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE2)", 1, 1.00f, "SceneFire.x", D3DXVECTOR3(0, 1.2f, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE2, TONE)", 1, 0.05f, "SceneFire.x", D3DXVECTOR3(0, 1.2f, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE2, TONE+BLOOM)", 0, 0.05f, "SceneFire.x", D3DXVECTOR3(0, 1.2f, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE=0.90)", 0, 0.90f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE=0.30)", 0, 0.30f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE=0.10)", 0, 0.10f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE=0.03)", 0, 0.03f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, TONE=0.01)", 0, 0.01f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, BRIGHT)", 2, 0.05f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE1, BLOOM)", 3, 0.05f, "SceneKamakura.x", D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE2, BRIGHT)", 2, 0.05f, "SceneFire.x", D3DXVECTOR3(0, 1.2f, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CHDR(this, "HDR(SCENE2, BLOOM)", 3, 0.05f, "SceneFire.x", D3DXVECTOR3(0, 1.2f, 0), D3DXVECTOR3(100, 90, 80)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(NOT SHADOWED)", 0, D3DXCOLOR(0, 0, 0, 0), D3DXCOLOR(0, 0, 0, 0)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(SHADOWED, 0.5)", 0, D3DXCOLOR(0, 0, 0, 0.5f), D3DXCOLOR(0, 0, 0, 0)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(SHADOWED, 0.2)", 0, D3DXCOLOR(0, 0, 0, 0.2f), D3DXCOLOR(0, 0, 0, 0)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(SHADOWED, 0.8)", 0, D3DXCOLOR(0, 0, 0, 0.8f), D3DXCOLOR(0, 0, 0, 0)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(SHADOW VOLUME)", 1, D3DXCOLOR(0, 0, 0, 0.5f), D3DXCOLOR(0, 0, 0, 0.5f)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(STENCIL)", 2, D3DXCOLOR(1, 1, 1, 1), D3DXCOLOR(0, 0, 0, 0)));
		Demo.push_back(new CShadowVolume(this, "SHADOW VOLUME(SHADOW VOLUME+SHADOW)", 1, D3DXCOLOR(0, 0, 0, 0.8f), D3DXCOLOR(0, 0, 0, 0.2f)));
		Demo.push_back(new CShadowMap(this, "SHADOW MAP(NOT SHADOWED)", 1, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CShadowMap(this, "SHADOW MAP(SHADOWED)", 0, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CShadowMap(this, "SHADOW MAP(SHADOW MAP)", 2, D3DXVECTOR4(1, 1, 1, 1)));
	}

	//==============================================================
	// VƎR̃GtFNg
	if (ArgExist("2") || ArgExist("nature") || ArgExist("all")) {
		Demo.push_back(new CTimePassage(this, "TIME PASSAGE(SUNRISE)", 0, 0));
		Demo.push_back(new CTimePassage(this, "TIME PASSAGE(DAY)", 1, 0));
		Demo.push_back(new CTimePassage(this, "TIME PASSAGE(SUNSET)", 2, 0));
		Demo.push_back(new CTimePassage(this, "TIME PASSAGE(NIGHT)", 3, 0));
		Demo.push_back(new CTimePassage(this, "TIME PASSAGE(PASSING)", 0, 0.02f));
		Demo.push_back(new CSnow(this, "SNOW(100)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(10)", "SceneKamakura.x", "Snow.png", 10, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(1000)", "SceneKamakura.x", "Snow.png", 1000, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(FRONT)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(0, 2, -7), D3DXVECTOR3(0, 3, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(TOP)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(0, 10, -1), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(BOTTOM)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(0, 0, -6), D3DXVECTOR3(0, 5, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(LEFT)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(-5, 3, -7), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(RIGHT)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(5, 3, -7), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(STAR)", "SceneKamakura.x", "Star.png", 100, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(BEAR)", "SceneKamakura.x", "Hig.png", 100, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0));
		Demo.push_back(new CSnow(this, "SNOW(SNOW, ROTATE)", "SceneKamakura.x", "Snow.png", 100, D3DXVECTOR3(5, 3, -7), D3DXVECTOR3(0, 1, 0), 0.01f));
		Demo.push_back(new CSnow(this, "SNOW(STAR, ROTATE)", "SceneKamakura.x", "Star.png", 100, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0.01f));
		Demo.push_back(new CSnow(this, "SNOW(BEAR, ROTATE)", "SceneKamakura.x", "Hig.png", 100, D3DXVECTOR3(0, 4, -10), D3DXVECTOR3(0, 1, 0), 0.01f));
		Demo.push_back(new CLeaf(this, "LEAF(100)", "SceneFire.x", "Leaf", 100, 1, 3, 0.01f, 0.001f, 1, 0.03f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -0.6f, 1), D3DXCOLOR(0.8f, 0.6f, 0.4f, 0)));
		Demo.push_back(new CLeaf(this, "LEAF(1000)", "SceneFire.x", "Leaf", 1000, 1, 3, 0.01f, 0.001f, 1, 0.03f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -0.6f, 1), D3DXCOLOR(0.8f, 0.6f, 0.4f, 0)));
		Demo.push_back(new CLeaf(this, "LEAF(TOP)", "SceneFire.x", "Leaf", 100, 1, 3, 0.01f, 0.001f, 1, 0.03f, D3DXVECTOR3(0, 10, -6), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -0.6f, 1), D3DXCOLOR(0.8f, 0.6f, 0.4f, 0)));
		Demo.push_back(new CLeaf(this, "LEAF(BOTTOM)", "SceneFire.x", "Leaf", 100, 1, 3, 0.01f, 0.001f, 1, 0.03f, D3DXVECTOR3(0, 0, -7), D3DXVECTOR3(0, 4, 0), 0, D3DXVECTOR3(1, -0.6f, 1), D3DXCOLOR(0.8f, 0.6f, 0.4f, 0)));
		Demo.push_back(new CLeaf(this, "LEAF(ROTATE)", "SceneFire.x", "Leaf", 100, 1, 3, 0.01f, 0.001f, 1, 0.03f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0.005f, D3DXVECTOR3(1, -0.6f, 1), D3DXCOLOR(0.8f, 0.6f, 0.4f, 0)));
		Demo.push_back(new CLeaf(this, "SAKURA(100)", "SceneSakura.x", "Sakura", 100, 1, 1.4f, 0.05f, 0.005f, 1, 0.05f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0)));
		Demo.push_back(new CLeaf(this, "SAKURA(1000)", "SceneSakura.x", "Sakura", 1000, 1, 1.4f, 0.05f, 0.005f, 1, 0.05f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0)));
		Demo.push_back(new CLeaf(this, "SAKURA(TOP)", "SceneSakura.x", "Sakura", 1000, 1, 1.4f, 0.05f, 0.005f, 1, 0.05f, D3DXVECTOR3(0, 10, -6), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0)));
		Demo.push_back(new CLeaf(this, "SAKURA(BOTTOM)", "SceneSakura.x", "Sakura", 1000, 1, 1.4f, 0.05f, 0.005f, 1, 0.05f, D3DXVECTOR3(0, 0, -7), D3DXVECTOR3(0, 4, 0), 0, D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0)));
		Demo.push_back(new CLeaf(this, "SAKURA(ROTATE)", "SceneSakura.x", "Sakura", 1000, 1, 1.4f, 0.05f, 0.005f, 1, 0.05f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0.005f, D3DXVECTOR3(1, -1, 1), D3DXCOLOR(0.8f, 0.9f, 1.0f, 0)));
		Demo.push_back(new CLeaf(this, "SPEAR(100)", "SceneSakura.x", "Spear", 100, 1, 1, 0, 0, 0, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, 1, 1), D3DXCOLOR(0.6f, 0.1f, 0.3f, 0)));
		Demo.push_back(new CLeaf(this, "SPEAR(1000)", "SceneSakura.x", "Spear", 1000, 1, 1, 0, 0, 0, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, 1, 1), D3DXCOLOR(0.6f, 0.1f, 0.3f, 0)));
		Demo.push_back(new CLeaf(this, "SPEAR(TOP)", "SceneSakura.x", "Spear", 100, 1, 1, 0, 0, 0, 0, D3DXVECTOR3(0, 10, -6), D3DXVECTOR3(0, 1, 0), 0, D3DXVECTOR3(1, 1, 1), D3DXCOLOR(0.6f, 0.1f, 0.3f, 0)));
		Demo.push_back(new CLeaf(this, "SPEAR(BOTTOM)", "SceneSakura.x", "Spear", 100, 1, 1, 0, 0, 0, 0, D3DXVECTOR3(0, 0, -7), D3DXVECTOR3(0, 4, 0), 0, D3DXVECTOR3(1, 1, 1), D3DXCOLOR(0.6f, 0.1f, 0.3f, 0)));
		Demo.push_back(new CLeaf(this, "SPEAR(ROTATE)", "SceneSakura.x", "Spear", 100, 1, 1, 0, 0, 0, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), 0.005f, D3DXVECTOR3(1, 1, 1), D3DXCOLOR(0.6f, 0.1f, 0.3f, 0)));
		Demo.push_back(new CRain(this, "RAIN(100)", 0, 100, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CRain(this, "RAIN(1000)", 0, 1000, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CRain(this, "RAIN(TOP)", 0, 1000, D3DXVECTOR3(0, 10, -6), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CRain(this, "RAIN(BOTTOM)", 0, 1000, D3DXVECTOR3(0, 0, -7), D3DXVECTOR3(0, 4, 0)));
		Demo.push_back(new CRain(this, "RAIN(ROTATE)", 0.01f, 1000, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CWave(this, "WAVE(NOON)", WAVE_STANDARD, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(SUNSET)", WAVE_STANDARD, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 1, -10), D3DXVECTOR3(0.8f, 0.6f, 0.4f)));
		Demo.push_back(new CWave(this, "WAVE(NOON, ROTATE)", WAVE_STANDARD, 0.005f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(SUNSET, ROTATE)", WAVE_STANDARD, 0.005f, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 1, -10), D3DXVECTOR3(0.8f, 0.6f, 0.4f)));
		Demo.push_back(new CWave(this, "WAVE(TOP)", WAVE_STANDARD, 0, D3DXVECTOR3(0, 15, -0.1f), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(HEIGHT)", WAVE_HEIGHT, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(VELOCITY)", WAVE_VELOCITY, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(NORMAL)", WAVE_NORMAL, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(NO SPECULAR)", WAVE_NOSPECULAR, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CWave(this, "WAVE(SPECULAR)", WAVE_STANDARD, 0, D3DXVECTOR3(0, 4, -8), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(0)", FUR_STANDARD,  0, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(10)", FUR_STANDARD, 10, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(20)", FUR_STANDARD, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(40)", FUR_STANDARD, 40, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(TOP)", FUR_STANDARD, 20, 0, D3DXVECTOR3(0, 8, -0.1f), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NEAR)", FUR_STANDARD, 20, 0, D3DXVECTOR3(0, 3, -3), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(ROTATE)", FUR_STANDARD, 20, 0.01f, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(FUR MESH)", FUR_FURMESH, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NO FUR MAP)", FUR_NOFUR, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(FUR MAP)", FUR_FURMAP, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NO NORMAL MAP)", FUR_NONORMAL, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NORMAL MAP)", FUR_NORMALMAP, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NO SPECULAR)", FUR_NOSPECULAR, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(FUR+NORMAL+SPECULAR)", FUR_STANDARD, 20, 0, D3DXVECTOR3(0, 3, -7), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NO CULLMODE)", FUR_NOCULLMODE, 10, 0, D3DXVECTOR3(0, 3, -3), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(CULLMODE)", FUR_STANDARD, 10, 0, D3DXVECTOR3(0, 3, -3), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(NO SORT)", FUR_NOSORT, 20, 0, D3DXVECTOR3(-6, 4, 0), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
		Demo.push_back(new CFur(this, "FUR(SORT)", FUR_STANDARD, 20, 0, D3DXVECTOR3(-6, 4, 0), D3DXVECTOR3(0, 1, 0), D3DXVECTOR3(-10, 10, -10), D3DXVECTOR3(0.9f, 0.9f, 1.0f)));
	}

	//==============================================================
	// Ɩ@̃GtFNg
	if (ArgExist("3") || ArgExist("magic") || ArgExist("all")) {
		Demo.push_back(new CSpark(this, "SPARK(100)", SPARK_STANDARD, 100, 0.02f, 0.02f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(1000)", SPARK_STANDARD, 1000, 0.02f, 0.02f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(10000)", SPARK_STANDARD, 10000, 0.02f, 0.02f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(POINT)", SPARK_POINT, 10000, 0.02f, 0.02f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(NARROW)", SPARK_STANDARD, 10000, 0.001f, 0.04f, 0, D3DXVECTOR3(5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(MEDIUM)", SPARK_STANDARD, 10000, 0.01f, 0.03f, 0, D3DXVECTOR3(5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(WIDE)", SPARK_STANDARD, 10000, 0.1f, 0.02f, 0, D3DXVECTOR3(5, 3, -3), D3DXVECTOR3(0, 1, 0)));	
		Demo.push_back(new CSpark(this, "SPARK(NO INIT LOOP)", SPARK_NOINITLOOP, 10000, 0.02f, 0.02f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSpark(this, "SPARK(ROTATE)", SPARK_STANDARD, 10000, 0.02f, 0.02f, 0.01f, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(WHITE)", SMOKE_STANDARD, 100, D3DXVECTOR3(0.9f, 0.9f, 0.9f), 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(PURPLE)", SMOKE_STANDARD, 100, D3DXVECTOR3(0.8f, 0.2f, 0.8f), 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(BLACK)", SMOKE_STANDARD, 100, D3DXVECTOR3(0.1f, 0.1f, 0.1f), 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(TOP)", SMOKE_STANDARD, 100, D3DXVECTOR3(0.9f, 0.9f, 0.9f), 0, D3DXVECTOR3(0, 8, -0.1f), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(ROTATE)", SMOKE_STANDARD, 100, D3DXVECTOR3(0.9f, 0.9f, 0.9f), 0.01f, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CSmoke(this, "SMOKE(WRITE Z)", SMOKE_ZWRITE, 100, D3DXVECTOR3(0.9f, 0.9f, 0.9f), 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(RED)", FIRE_STANDARD, 100, D3DXVECTOR3(0.3f, 0.1f, 0.1f), 1.0f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(BLUE)", FIRE_STANDARD, 100, D3DXVECTOR3(0.05f, 0.05f, 0.2f), 1.0f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(THIN)", FIRE_STANDARD, 100, D3DXVECTOR3(0.3f, 0.1f, 0.1f), 0.3f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(THICK)", FIRE_STANDARD, 100, D3DXVECTOR3(0.3f, 0.1f, 0.1f), 1.5f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(NO ADDITIVE BLENDING)", FIRE_NOADDBLEND, 100, D3DXVECTOR3(0.3f, 0.1f, 0.1f), 1.0f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CFire(this, "FIRE(WRITE Z)", FIRE_ZWRITE, 100, D3DXVECTOR3(0.3f, 0.1f, 0.1f), 1.0f, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CBlood(this, "BLOOD(100)", BLOOD_STANDARD, 100, D3DXVECTOR3(0.4f, 0.1f, 0.1f), 0, D3DXVECTOR3(-6, 1, -6), D3DXVECTOR3(0, 2.5f, 0)));
		Demo.push_back(new CBlood(this, "BLOOD(1000)", BLOOD_STANDARD, 1000, D3DXVECTOR3(0.4f, 0.1f, 0.1f), 0, D3DXVECTOR3(-6, 1, -6), D3DXVECTOR3(0, 2.5f, 0)));
		Demo.push_back(new CBlood(this, "BLOOD(TOP)", BLOOD_STANDARD, 1000, D3DXVECTOR3(0.4f, 0.1f, 0.1f), 0, D3DXVECTOR3(0, 10, -3), D3DXVECTOR3(0, 2.5f, -1)));
		Demo.push_back(new CBlood(this, "BLOOD(ROTATE)", BLOOD_STANDARD, 1000, D3DXVECTOR3(0.4f, 0.1f, 0.1f), 0.01f, D3DXVECTOR3(-6, 1, -6), D3DXVECTOR3(0, 2.5f, 0)));
		Demo.push_back(new CMagicCircle(this, "MAGIC CIRCLE", MAGICCIRCLE_STANDARD, 10000, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CMagicCircle(this, "MAGIC CIRCLE(TOP)", MAGICCIRCLE_STANDARD, 10000, 0, D3DXVECTOR3(0, 10, -0.1f), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CMagicCircle(this, "MAGIC CIRCLE(ROTATE)", MAGICCIRCLE_STANDARD, 10000, -0.01f, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CMagicCircle(this, "MAGIC CIRCLE(NO PARTICLES)", MAGICCIRCLE_NOPARTICLE, 10000, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CMagicCircle(this, "MAGIC CIRCLE(NO ADDITIVE BLENDING)", MAGICCIRCLE_NOADDBLEND, 10000, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CIce(this, "ICE", ICE_STANDARD, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CIce(this, "ICE(TOP)", ICE_STANDARD, 0, D3DXVECTOR3(0, 10, -0.1f), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CIce(this, "ICE(ROTATE)", ICE_STANDARD, 0.01f, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CIce(this, "ICE(NO ADDITIVE BLENDING)", ICE_NOADDBLEND, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM)", VOLUMEFOG_STANDARD, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, NEAR)", VOLUMEFOG_STANDARD, 0, D3DXVECTOR3(3, 3, -1), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, ROTATE)", VOLUMEFOG_STANDARD, 0.01f, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, DEPTH SCENE)", VOLUMEFOG_DEPTHSCENE, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, DEPTH CW)", VOLUMEFOG_DEPTHCW, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, DEPTH CCW)", VOLUMEFOG_DEPTHCCW, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(ROOM, DEPTH CW-CCW)", VOLUMEFOG_DEPTHDIFF, 0, D3DXVECTOR3(-5, 3, -3), D3DXVECTOR3(0, 1, 0), "SceneMagic", 0.8f, D3DXVECTOR4(1, 1, 1, 0.8f)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY)", VOLUMEFOG_STANDARD, 0, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, TOP)", VOLUMEFOG_STANDARD, 0, D3DXVECTOR3(0, 20, -0.1f), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, ROTATE)", VOLUMEFOG_STANDARD, 0.01f, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, DEPTH SCENE)", VOLUMEFOG_DEPTHSCENE, 0, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, DEPTH CW)", VOLUMEFOG_DEPTHCW, 0, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, DEPTH CCW)", VOLUMEFOG_DEPTHCCW, 0, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
		Demo.push_back(new CVolumeFog(this, "VOLUME FOG(VALLEY, DEPTH CW-CCW)", VOLUMEFOG_DEPTHDIFF, 0, D3DXVECTOR3(10, 3, -3), D3DXVECTOR3(0, -2, 0), "SceneValley", 0.2f, D3DXVECTOR4(1, 1, 1, 1)));
	}

	//==============================================================
	// ̃GtFNg
	if (ArgExist("4") || ArgExist("motion") || ArgExist("all")) {
		Demo.push_back(new CBlur(this, "BLUR(NONE)", 0));
		Demo.push_back(new CBlur(this, "BLUR(WEAK)", 0.5f));
		Demo.push_back(new CBlur(this, "BLUR(STRONG)", 0.9999f));
		Demo.push_back(new CBlur(this, "ZOOM BLUR", 0.9999f, 1.02f));
		Demo.push_back(new CBlur(this, "ZOOM&ROTATE BLUR", 0.9999f, 1.02f, 0.01f));
		Demo.push_back(new CLightTrail(this, "LIGHT TRAIL(SHORT)", 0, 0.60f));
		Demo.push_back(new CLightTrail(this, "LIGHT TRAIL(LONG)", 0, 0.95f));
		Demo.push_back(new CLightTrail(this, "LIGHT TRAIL(CLEAR ZBUFFER)", 1, 0.95f));
		Demo.push_back(new CStealth(this));
		Demo.push_back(new CFootmark(this, "FOOTMARK(A)", "FootmarkA.png"));
		Demo.push_back(new CFootmark(this, "FOOTMARK(B)", "FootmarkB.png"));
		Demo.push_back(new CTireTrack(this, "TIRE TRACK(1)", 1));
		Demo.push_back(new CTireTrack(this, "TIRE TRACK(2)", 2));
		Demo.push_back(new CTireTrack(this, "TIRE TRACK(3)", 3));
		Demo.push_back(new CFocusLine(this, "FOCUS LINE(50)", 0, 50, 0.02f));
		Demo.push_back(new CFocusLine(this, "FOCUS LINE(100)", 0, 100, 0.02f));
		Demo.push_back(new CFocusLine(this, "FOCUS LINE(200)", 0, 200, 0.02f));
		Demo.push_back(new CFocusLine(this, "FOCUS LINE(MASK)", 1, 100, 0.02f));
		Demo.push_back(new CFocusLine(this, "FOCUS LINE(INSIDE)", 0, 100, -0.02f));
		Demo.push_back(new CExplosion(this, "EXPLOSION", 0));
		Demo.push_back(new CExplosion(this, "EXPLOSION(ZOOM ONLY)", 1));
	}

	//==============================================================
	// J̃GtFNg
	if (ArgExist("5") || ArgExist("camera") || ArgExist("all")) {
		Demo.push_back(new CYIQ(this, "MONOCHROME", 0, 0, 
			"SceneDiningA.x", D3DXVECTOR3(0, 4, 8), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CYIQ(this, "SEPIA", 0.2f, 0, 
			"SceneDiningB.x", D3DXVECTOR3(0, 4, 8), D3DXVECTOR3(0, 1, 0)));
		Demo.push_back(new CLiveMonitor(this));
		Demo.push_back(new CScanline(this, "SCANLINE(1.00)", 1.00f));
		Demo.push_back(new CScanline(this, "SCANLINE(0.75)", 0.75f));
		Demo.push_back(new CScanline(this, "SCANLINE(0.50)", 0.50f));
		Demo.push_back(new CScanline(this, "SCANLINE(0.25)", 0.25f));
		Demo.push_back(new CNoise(this, "NOISE(1000)", 0, 1000, 0.2f, 1.0f));
		Demo.push_back(new CNoise(this, "NOISE(200)", 0, 200, 0.2f, 1.0f));
		Demo.push_back(new CNoise(this, "NOISE(50)", 0, 50, 0.2f, 1.0f));
		Demo.push_back(new CNoise(this, "NOISE(TEXTURE)", 1, 200, 0.2f, 1.0f));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(DISABLE)", 0, 0, 1));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(NEAR)", 40, 0.01f, 0));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(MEDIUM)", 100, 0.01f, 0));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(FAR)", 160, 0.01f, 0));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(DEPTH,NEAR)", 40, 0.01f, 2));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(DEPTH,MEDIUM)", 100, 0.01f, 2));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(DEPTH,FAR)", 160, 0.01f, 2));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(TEXTURE0)", 0, 0, 3));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(TEXTURE1)", 0, 0, 4));
		Demo.push_back(new CDepthOfField(this, "DEPTH OF FIELD(TEXTURE2)", 0, 0, 5));
		Demo.push_back(new CMovieFilm(this, "MOVIE FILM(ORIGINAL)", 0, 0, 0, 0, 0, 0, 0, 0, 1, 1));
		Demo.push_back(new CMovieFilm(this, "MOVIE FILM(OLD)", 0, 0.05f, -0.05f, 4, 0.05f, 0.02f, 500, 5, 0.8f, 1.0f));
		Demo.push_back(new CMovieFilm(this, "MOVIE FILM(VERY OLD)", 0, 0.1f, -0.1f, 20, 0.2f, 0.1f, 500, 5, 0.6f, 1.0f));
		Demo.push_back(new CMovieFilm(this, "MOVIE FILM(NOISE)", 1, 0.1f, -0.1f, 20, 0.2f, 0.1f, 500, 5, 0.6f, 1.0f));	
	}

	//==============================================================
	// ʓ]̃GtFNg
	if (ArgExist("6") || ArgExist("scene") || ArgExist("all")) {
		Demo.push_back(new CFadeInOut(this, "FADE IN/OUT"));
		Demo.push_back(new CColorInOut(this, "COLOR IN/OUT(WHITE)", D3DXCOLOR(1, 1, 1, 1)));
		Demo.push_back(new CColorInOut(this, "COLOR IN/OUT(BLACK)", D3DXCOLOR(0, 0, 0, 1)));
		Demo.push_back(new CColorInOut(this, "COLOR IN/OUT(RED)", D3DXCOLOR(1, 0, 0, 1)));
		Demo.push_back(new CMosaic(this, "MOSAIC"));
		Demo.push_back(new CRaster(this, "RASTER"));
		Demo.push_back(new CSpiral(this, "SPIRAL"));
		Demo.push_back(new CCutIn(this, "CUT IN"));
		Demo.push_back(new CPeephole(this, "PEEPHOLE(CIRCLE)", "PeepholeCircle.png", 0));
		Demo.push_back(new CPeephole(this, "PEEPHOLE(BEAR)", "PeepholeHig.png", 0));
		Demo.push_back(new CPeephole(this, "PEEPHOLE(PENGUIN)", "PeepholePen.png", 0));
		Demo.push_back(new CPeephole(this, "PEEPHOLE(PENGUIN, WRAP)", "PeepholePen.png", 1));
	}

	//==============================================================
	// ̑
	if (ArgExist("nenga")) {
		Demo.push_back(new CNenga2006(this, "", "SceneNenga.x", "Snow.png", 200, D3DXVECTOR3(0, 2.9f, -7), D3DXVECTOR3(0, 1.5f, 0), 0));		
		Demo.push_back(new CBasic(this, "BASIC"));
	}
	if (ArgExist("cover")) {
		Demo.push_back(new CCoverWave(this, 0.00f, D3DXVECTOR3(0, 1+3*0.54f, -8*0.54f), D3DXVECTOR3(0, 1-0.5f, 0), 5000));
		Demo.push_back(new CCoverWave(this, 0.00f, D3DXVECTOR3(0, 1+3*0.54f, -8*0.54f), D3DXVECTOR3(0, 1-0.5f, 0), 3000));
		Demo.push_back(new CCoverWave(this, 0.00f, D3DXVECTOR3(0, 1+3*0.54f, -8*0.54f), D3DXVECTOR3(0, 1-0.5f, 0), 2000));
		Demo.push_back(new CCoverWave(this, 0.00f, D3DXVECTOR3(0, 1+3*0.54f, -8*0.54f), D3DXVECTOR3(0, 1-0.5f, 0), 1000));
		Demo.push_back(new CCoverTakibi(this, 0.00f, D3DXVECTOR3(0, 3.0f, -2), D3DXVECTOR3(0, 1.7f, 0)));
		Demo.push_back(new CCoverTakibi(this, 0.00f, D3DXVECTOR3(0, 3, -2), D3DXVECTOR3(0, 2, 0)));
		Demo.push_back(new CCoverMonitor(this, 0.00f, D3DXVECTOR3(3.0f, 1.5f, -5.0f), D3DXVECTOR3(-2.3f, -1.5f, 0)));
		Demo.push_back(new CCoverFire(this, "", 0, 0.00f, D3DXVECTOR3(0, 1.0f, -4.5f), D3DXVECTOR3(0, 0, 0)));
		Demo.push_back(new CCoverFire(this, "", 0, 0.00f, D3DXVECTOR3(0, 0.9f, -3.5f), D3DXVECTOR3(0, 0, 0)));
		Demo.push_back(new CBasic(this, "BASIC"));
	}

	//==============================================================
	// _~[̃f
	if (Demo.empty()) Demo.push_back(new CBasic(this, "BASIC"));
}


//==============================================================
// fXgN^
CMain::~CMain() {
	OnLostDevice();
	for (int i=0, n=(int)Demo.size(); i<n; i++) delete Demo[i];
	delete ImageGroup;
	delete Font;
	delete[] WorkTexture;
	delete[] WorkDepthStencil;
}


//==============================================================
// 
void CMain::Move() {

	// ͂̍XV
	Input->UpdateState();
	const CInputState* is=Input->GetState(0);

	if (!PrevInput) {
		if (is->Left) CurrentDemo--;
		if (is->Right) CurrentDemo++;
		CurrentDemo=(CurrentDemo+(int)Demo.size())%(int)Demo.size();
	}
	PrevInput=is->Left||is->Right;

	// f̊Jn
	if (PrevDemo!=CurrentDemo) Demo[CurrentDemo]->Init();
	PrevDemo=CurrentDemo;
	
	// f̓
	if (!is->Button[0]) Demo[CurrentDemo]->Move();
}


//==============================================================
// `
void CMain::Draw() {

	// ef̕`
	Demo[CurrentDemo]->Draw();
	
	// G[\
	string s=Demo[CurrentDemo]->GetError();
	if (!s.empty()) {
		Graphics->Clear();
		Font->DrawText("NOT AVAILABLE("+s+")", 0, 40, 
			D3DXCOLOR(1, 1, 1, 1), D3DXCOLOR(0.5, 0.5, 0.5, 0.5));
	}

	// ^Cg\
	if (Demo.size()>=2) {
		Font->DrawText(Demo[CurrentDemo]->GetTitle(), 0, 0, 
			D3DXCOLOR(1, 1, 1, 1), D3DXCOLOR(0.5, 0.5, 0.5, 0.5));
	} else {
		Font->DrawText("USE .BAT FILES TO RUN OTHER DEMOS", 0, 0, 
			D3DXCOLOR(1, 1, 1, 1), D3DXCOLOR(0.5, 0.5, 0.5, 0.5));	
	}
}


//==============================================================
// foCX̊Ǘ

void CMain::OnLostDevice() {
	SAFE_RELEASE(DummyTexture);
	for (int i=0, n=GetWorkCount(); i<n; i++) {
		SAFE_RELEASE(WorkTexture[i]);
		SAFE_RELEASE(WorkDepthStencil[i]);
	}
	CDemo::OnLostDeviceStatic();
	for (int i=0, n=(int)Demo.size(); i<n; i++) Demo[i]->OnLostDevice();
}

void CMain::OnResetDevice() {
	LPDIRECT3DDEVICE9 device=Graphics->GetDevice();

	// _O̐ݒ
	device->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	device->SetRenderState(D3DRS_LIGHTING, TRUE);
	device->SetRenderState(D3DRS_ZENABLE, TRUE);

	// At@ufBO̗L
	device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

	// eNX`@̐ݒ
	device->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
	device->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	device->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	device->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
	device->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);

	// eNX`Tv̐ݒ
	device->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	device->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	device->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);

	// _~[̃eNX`
	device->CreateTexture(
		1, 1, 1, D3DUSAGE_RENDERTARGET, 
		D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &DummyTexture, NULL);
	D3DXVECTOR4 color(1, 1, 1, 1);
	D3DXFillTexture(DummyTexture, FillTexture, &color);

	// eNX`̍쐬
	int w=Graphics->GetWidth(), h=Graphics->GetHeight();
	for (int i=0, n=GetWorkCount(); i<n; i++) {
		device->CreateTexture(
			w, h, 1, D3DUSAGE_RENDERTARGET, 
			D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &WorkTexture[i], NULL);
		device->CreateDepthStencilSurface(
			w, h, D3DFMT_D16, 
			D3DMULTISAMPLE_NONE, 0, TRUE, &WorkDepthStencil[i], NULL);
	}

	// ef̃foCXA
	CDemo::OnResetDeviceStatic();
	for (int i=0, n=(int)Demo.size(); i<n; i++) Demo[i]->OnResetDevice();
	Demo[CurrentDemo]->Init();
}


//==============================================================
// C[`
INT WINAPI WinMain(HINSTANCE hinst, HINSTANCE, LPSTR, INT) {
	CMain* main=new CMain();
	main->FPS=60;
	main->PauseInTheBackground=true;
	main->DropFrames=false;
	main->Run();
	delete main;
	return 0;
}

