#include "Main.h"
#include "Mosaic.h"


//==============================================================
// UCN

// RXgN^
CMosaic::CMosaic(CMain* main, string title)
:	CDemo(main, title), 
	Scale(1), VScale(0), Time(0), Index(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneMahjong.x");
}

// fXgN^
CMosaic::~CMosaic() {
}
	
// ړ
void CMosaic::Move() {
	
	// g嗦̕ω
	if (Scale<=0.005f) {
		Scale=0.005f;
		VScale=1.02f;
		
		// V[̐؂ւ
		Index=(Index+1)%4;
	}
	if (Scale>=1.0f) {
		Scale=1.0f;
		VScale=0.98f;
	}
	Scale*=VScale;

	// Ԃ̍XV
	Time++;
}

// `
void CMosaic::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from[]={
		D3DXVECTOR3(3, 2, -3),
		D3DXVECTOR3(-3, 2, -3),
		D3DXVECTOR3(-3, 2, 3),
		D3DXVECTOR3(3, 2, 3)
	};
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from[Index], &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`ɃbV`
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	D3DVIEWPORT9 viewport={0, 0, w*Scale, h*Scale, 0, 1};
	Device->SetViewport(&viewport);
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// eNX`ʂɕ`
	ResetRenderTarget();
	SetSamplerState(0, D3DTEXF_POINT);
	DrawTexture(WorkTexture[0], 0, 0, w, h, 0, 0, Scale, Scale, D3DXCOLOR(1, 1, 1, 1));
	SetSamplerState(0, D3DTEXF_LINEAR);
}

