#include "Main.h"
#include "Rain.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }


//==============================================================
// J

// RXgN^
CRainDrop::CRainDrop(
	CMesh* ripple, 
	float min_y, float max_y, float max_xz, 
	float min_vy, float max_vy, float max_vxz, 
	D3DXVECTOR3 base_dir, float rand_dir, 
	float min_size, float max_size
) 
:	MeshRipple(ripple),
	MinY(min_y), MaxY(max_y), MaxXZ(max_xz), 
	MinVY(min_vy), MaxVY(max_vy), MaxVXZ(max_vxz), 
	BaseDir(base_dir), RandDir(rand_dir), 
	MinSize(min_size), MaxSize(max_size)
{
	// WAxAATCY̐ݒ
	Init();
}

// 
void CRainDrop::Init() {

	// WAx
	Pos=D3DXVECTOR3(Rand05()*MaxXZ, Rand1()*MaxY, Rand05()*MaxXZ);
	VPos=D3DXVECTOR3(Rand1()*MaxVXZ, MinVY+(MaxVY-MinVY)*Rand1(), Rand1()*MaxVXZ);
	APos=D3DXVECTOR3(Rand1()*MaxVXZ, MinVY+(MaxVY-MinVY)*Rand1(), Rand1()*MaxVXZ)*0.01f;

	// ATCY
	Dir=BaseDir+D3DXVECTOR3(Rand1(), Rand1(), Rand1())*RandDir;
	Size=MinSize+(MaxSize-MinSize)*Rand1();
	
	// 
	State=0;
}

// ړ
void CRainDrop::Move() {

	// J̓
	if (State==0) {
		Pos+=VPos;
		VPos+=APos;
		
		// nʂɓBgɕς
		if (Pos.y<0) {
			State=1;
			Time=0;
			RippleTime=(int)(15+Rand1()*5);
			Pos.y=MinY;
			Dir=D3DXVECTOR3(0, 0, 0);
			Size=0;
		}
	}
	
	// g̓
	else {
		Time++;
		Size=Time*0.01f;
		
		// 莞Ԃo߂JƂčď
		if (Time>RippleTime) {
			Init();
			Pos.y=MaxY;
		}
	}
}

// `
void CRainDrop::Draw(
	LPDIRECT3DDEVICE9 device, const D3DXMATRIX* world,
	RAIN_VERTEX* drop_vertex, RAIN_VERTEX* ripple_vertex
) {
	// gkA]Aړ̂߂̍s쐬
	D3DXMATRIX m0, m1, m2;
	D3DXMatrixScaling(&m0, Size, Size, Size);
	D3DXMatrixRotationYawPitchRoll(&m1, Dir.x, Dir.y, Dir.z);
	D3DXMatrixTranslation(&m2, Pos.x, Pos.y, Pos.z);
	
	// [hs̐ݒ	
	D3DXMatrixMultiply(&m0, &m0, &m1);
	D3DXMatrixMultiply(&m0, &m0, &m2);
	D3DXMatrixMultiply(&m0, &m0, world);
	device->SetTransform(D3DTS_WORLD, &m0);

	// _O̐ݒ
	device->SetRenderState(D3DRS_AMBIENT, D3DXCOLOR(1, 1, 1, 1));
	device->SetFVF(D3DFVF_RAIN_VERTEX);
	D3DMATERIAL9 mat;
	ZeroMemory(&mat, sizeof(mat));
	device->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL);

	// J̕`
	if (State==0) {
		mat.Diffuse=mat.Ambient=D3DXCOLOR(1, 1, 1, sin(D3DX_PI*(MaxY-Pos.y)/MaxY));
		device->SetMaterial(&mat);
		device->DrawPrimitiveUP(D3DPT_LINELIST, 1, drop_vertex, sizeof(RAIN_VERTEX));
	}
	
	// g̕`
	else {
		mat.Diffuse=mat.Ambient=D3DXCOLOR(1, 1, 1, (float)(RippleTime-Time)/RippleTime);
		device->SetMaterial(&mat);
		device->DrawPrimitiveUP(D3DPT_LINESTRIP, RIPPLE_VERTEX_COUNT-1, ripple_vertex, sizeof(RAIN_VERTEX));
	}
}


//==============================================================
// J̃f

// RXgN^
CRain::CRain(
	CMain* main, string title, 
	float vyaw, int rain_count, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), 
	Yaw(0), VYaw(vyaw), RainCount(rain_count), 
	From(from), Lookat(lookat)
{
	// bṼ[h
	MeshScene=LoadMesh("SceneRain.x");
	MeshRipple=LoadMesh("Ripple.x");

	// J̍쐬
	Rain=new CRainDrop*[RainCount];
	for (int i=0; i<RainCount; i++) {
		Rain[i]=new CRainDrop(MeshRipple, 0.01f, 10, 10, -0.1f, -0.2f, 0.05f, D3DXVECTOR3(0, 0, 0.1f), 0.01f, 1.0f, 1.1f);
	}

	// J̒_f[^̍쐬
	DropVertex[0].Pos=D3DXVECTOR3(0, 0.5f, 0);
	DropVertex[1].Pos=D3DXVECTOR3(0, -0.5f, 0);
	DropVertex[0].Color=DropVertex[1].Color=D3DXCOLOR(1, 1, 1, 1);

	// g̒_f[^̍쐬
	for (int i=0; i<RIPPLE_VERTEX_COUNT; i++) {
		float rad=D3DX_PI*2*i/(RIPPLE_VERTEX_COUNT-1);
		RippleVertex[i].Pos=D3DXVECTOR3(cos(rad), 0, sin(rad));
		RippleVertex[i].Color=D3DXCOLOR(1, 0, 1, 1);
	}
}

// fXgN^
CRain::~CRain() {
	for (int i=0; i<RainCount; i++) delete Rain[i];
	delete[] Rain;
}
	
// ړ
void CRain::Move() {

	// V[̉]
	Yaw+=VYaw;

	// J̈ړ
	for (int i=0; i<RainCount; i++) Rain[i]->Move();
}

// `
void CRain::Draw() {

	// G[`FbN
	if (!MeshScene) { Error="MeshScene"; return; }
	if (!MeshRipple) { Error="MeshRipple"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, D3DXVECTOR3(0, 0, 0), 
		D3DXVECTOR3(1, -0.5f, 1), D3DXCOLOR(0.5f, 0.6f, 0.7f, 0), 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	MeshScene->Draw();

	// J̕`
	for (int i=0; i<RainCount; i++) Rain[i]->Draw(Device, &world, DropVertex, RippleVertex);
}

