#ifndef RAINH
#define RAINH

#include "..\LibGame\Mesh.h"
#include "Demo.h"


//==============================================================
// _`

// \
struct RAIN_VERTEX
{
	// _W
	D3DXVECTOR3 Pos;
	
	// F
	D3DXCOLOR Color;
};

// FVF
#define D3DFVF_RAIN_VERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)


//==============================================================
// J

// NX
class CRainDrop {
protected:

	// WAx
	D3DXVECTOR3 Pos, VPos, APos;
	float MinY, MaxY, MaxXZ, MinVY, MaxVY, MaxVXZ;
	
	// 
	D3DXVECTOR3 Dir, BaseDir;
	float RandDir;

	// 
	float Size, MinSize, MaxSize;
	
	// ǧ`
	CMesh *MeshRipple;
	
	// ԁA^C}[
	int State, Time, RippleTime;
	
public:

	// RXgN^
	CRainDrop(
		CMesh* ripple, 
		float min_y, float max_y, float max_xz, 
		float min_vy, float max_vy, float max_vxz, 
		D3DXVECTOR3 base_dir, float rand_dir, 
		float min_size, float max_size
	);

	// AړA`
	void Init();
	void Move();
	void Draw(
		LPDIRECT3DDEVICE9 device, const D3DXMATRIX* world,
		RAIN_VERTEX* drop_vertex, RAIN_VERTEX* ripple_vertex
	);
};


//==============================================================
// J̃f

#define RIPPLE_VERTEX_COUNT 17

class CRain : public CDemo {
protected:

	CMesh *MeshScene, *MeshRipple;
	float Yaw, VYaw;
	CRainDrop** Rain;
	int RainCount;
	D3DXVECTOR3 From, Lookat;

	// J̒_f[^
	RAIN_VERTEX DropVertex[4];

	// g̒_f[^
	RAIN_VERTEX RippleVertex[RIPPLE_VERTEX_COUNT];

public:

	// RXgN^AfXgN^
	CRain(
		CMain* main, string title, 
		float vyaw, int rain_count, 
		D3DXVECTOR3 from, D3DXVECTOR3 lookat
	);
	virtual ~CRain();
	
	// ړA`
	virtual void Move();
	virtual void Draw();
};


#endif

