#include "Main.h"
#include "Raster.h"


//==============================================================
// X^[XN[

// RXgN^
CRaster::CRaster(CMain* main, string title)
:	CDemo(main, title), 
	XScale(0.3f), YScale(10), YOffset(0), Time(0), Index(0)
{
	// bṼ[h
	Mesh=LoadMesh("SceneMahjong.x");

	// GtFNg̃[h
	Effect=LoadEffect("Raster.fx");
}

// fXgN^
CRaster::~CRaster() {
}
	
// ړ
void CRaster::Move() {

	// ʂ˂点
	XScale=(0.5f-cos(D3DX_PI*2*Time*0.002f)*0.5f)*4.0f;
	YOffset+=0.05f;

	// V[̐؂ւ
	Index=(Time+250)/500%4;

	// Ԃ̍XV
	Time++;
}

// `
void CRaster::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!PS20()) { Error="PS2.0"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from[]={
		D3DXVECTOR3(5, 3, -5),
		D3DXVECTOR3(-5, 3, -5),
		D3DXVECTOR3(-5, 3, 5),
		D3DXVECTOR3(5, 3, 5)
	};
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from[Index], &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`ɃbV`
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// GtFNgKpăeNX`ʂɕ`
	ResetRenderTarget();
	Effect->SetFloat("XScale", XScale);
	Effect->SetFloat("YScale", YScale);
	Effect->SetFloat("YOffset", YOffset);
	Effect->SetTexture("Tex", WorkTexture[0]);
	Effect->SetTechnique("Raster");
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
}

