#include "Main.h"
#include "Snow.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }


//==============================================================
// ᗱ

// RXgN^
CEachSnow::CEachSnow(
	float vy, float max_xz, float max_y, 
	float min_size, float max_size
) 
:	VY(vy), MaxXZ(max_xz), MaxY(max_y), 
	MinSize(min_size), MaxSize(max_size)
{
	Pos=D3DXVECTOR3(Rand05()*MaxXZ, Rand1()*MaxY, Rand05()*MaxXZ);
	Size=MinSize+(MaxSize-MinSize)*Rand1();

	// eNX`W
	Vertex[0].UV=D3DXVECTOR2(0, 0);
	Vertex[1].UV=D3DXVECTOR2(1, 0);
	Vertex[2].UV=D3DXVECTOR2(0, 1);
	Vertex[3].UV=D3DXVECTOR2(1, 1);
}

// ړ
void CEachSnow::Move() {
	Pos.y+=VY;
	if (Pos.y<0) {
		Pos=D3DXVECTOR3(Rand05()*MaxXZ, MaxY, Rand05()*MaxXZ);
		Size=MinSize+(MaxSize-MinSize)*Rand1();
	}
}

// _W̐ݒ
void CEachSnow::SetVertex(
	D3DXMATRIX* wview
) {
	D3DXVECTOR4 v=D3DXVECTOR4(Pos, 1);
	D3DXVec4Transform(&v, &v, wview);
	Vertex[0].Pos=D3DXVECTOR3(v.x-Size, v.y+Size, v.z);
	Vertex[1].Pos=D3DXVECTOR3(v.x+Size, v.y+Size, v.z);
	Vertex[2].Pos=D3DXVECTOR3(v.x-Size, v.y-Size, v.z);
	Vertex[3].Pos=D3DXVECTOR3(v.x+Size, v.y-Size, v.z);
}

// sɂ\[g
int CEachSnow::Compare(const void* a, const void* b) {
	float 
		za=(*(CEachSnow**)a)->Vertex[0].Pos.z,
		zb=(*(CEachSnow**)b)->Vertex[0].Pos.z,
		diff=zb-za;
	return ceil(diff)+floor(diff);
}

// `
void CEachSnow::Draw(
	LPDIRECT3DDEVICE9 device, 
	ID3DXEffect* effect
) {
	// F
	D3DXVECTOR4 color(1, 1, 1, sin(D3DX_PI*(MaxY-Pos.y)/MaxY));
	effect->SetVector("Color", &color);	

	// v~eBu̕`
	UINT p, np;
	effect->Begin(&np, 0);
	for (p=0; p<np; p++) {
		effect->BeginPass(p);
		device->DrawPrimitiveUP(
			D3DPT_TRIANGLESTRIP, 2, 
			Vertex, sizeof(SNOW_VERTEX));
		effect->EndPass();
	}
	effect->End();
}


//==============================================================
// ̃f

// RXgN^
CSnow::CSnow(
	CMain* main, string title, 
	string mesh, string texture, 
	int snow_count, 
	D3DXVECTOR3 from, D3DXVECTOR3 lookat, 
	float vyaw
)
:	CDemo(main, title), Yaw(0), VYaw(vyaw),
	SnowCount(snow_count), 
	From(from), Lookat(lookat)
{
	// bṼ[h
	Mesh=LoadMesh(mesh);

	// GtFNg̃[h
	Effect=LoadEffect("Snow.fx");

	// eNX`̃[h
	Texture=LoadTexture(texture);
	
	// ᗱ̍쐬
	Snow=new CEachSnow*[SnowCount];
	for (int i=0; i<SnowCount; i++) {
		Snow[i]=new CEachSnow(-0.01f, 10, 5, 0.05f, 0.1f);
	}
}

// fXgN^
CSnow::~CSnow() {
	for (int i=0; i<SnowCount; i++) delete Snow[i];
	delete[] Snow;
}
	
// ړ
void CSnow::Move() {

	// V[̉]
	Yaw+=VYaw;

	// ᗱ𓮂
	for (int i=0; i<SnowCount; i++) {
		Snow[i]->Move();
	}
}

// `
void CSnow::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!Texture) { Error="Texture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, 
		D3DXVECTOR3(0, 0, 0), D3DXVECTOR3(1, -1, 1), 
		D3DXCOLOR(0.2f, 0.2f, 0.8f, 0), 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// ᗱ̕`
	Device->SetFVF(D3DFVF_SNOW_VERTEX);
	Effect->SetMatrix("Proj", &proj);
	Effect->SetTexture("Tex", Texture);
	Effect->SetTechnique("Snow");
	D3DXMATRIX wview;
	D3DXMatrixMultiply(&wview, &world, &view);
	for (int i=0; i<SnowCount; i++) {
		Snow[i]->SetVertex(&wview);
	}
	qsort(Snow, SnowCount, sizeof(CEachSnow*), CEachSnow::Compare);
	for (int i=0; i<SnowCount; i++) {
		Snow[i]->Draw(Device, Effect);
	}
}

// `iN2006j
void CNenga2006::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!Texture) { Error="Texture"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 0.8f, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_DIRECTIONAL, 
		D3DXVECTOR3(0, 0, 0), D3DXVECTOR3(1, -1, 1), 
		D3DXCOLOR(0.1f, 0.1f, 0.4f, 0), 1000);
	Graphics->SetLight(
		1, D3DLIGHT_POINT, 
		D3DXVECTOR3(0, 1.5f, 0), D3DXVECTOR3(0, 0, 0), 
		D3DXCOLOR(0.6f, 0.3f, 0.1f, 0), 4);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.3f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(D3DXCOLOR(0, 0, 0.2f, 1));
	Mesh->Draw();

	// ᗱ̕`
	Device->SetFVF(D3DFVF_SNOW_VERTEX);
	Effect->SetMatrix("Proj", &proj);
	Effect->SetTexture("Tex", Texture);
	Effect->SetTechnique("Snow");
	D3DXMATRIX wview;
	D3DXMatrixMultiply(&wview, &world, &view);
	for (int i=0; i<SnowCount; i++) {
		Snow[i]->SetVertex(&wview);
	}
	qsort(Snow, SnowCount, sizeof(CEachSnow*), CEachSnow::Compare);
	for (int i=0; i<SnowCount; i++) {
		Snow[i]->Draw(Device, Effect);
	}
}

