#include "Main.h"
#include "Spark.h"


// 
static CRand Rand;
static float Rand1() { return Rand.Real1(); }
static float Rand05() { return Rand.Real1()-0.5f; }

// 萔
static const float
	InitX=0.25f, InitY=1.5f, InitZ=-0.6f,
	MinColor=0.3f, APosY=-0.0005f; 

//==============================================================
// Ή

// RXgN^
CEachSpark::CEachSpark(float max_vxz, float max_vy, int init_loop)
:	MaxVXZ(max_vxz), MaxVY(max_vy)
{
	Init();
	for (int i=0, n=Rand1()*init_loop; i<n; i++) Move();
}

// 
void CEachSpark::Init() {
	Vertex[0].Pos=Vertex[1].Pos=D3DXVECTOR3(InitX, InitY, InitZ);
	VPos=D3DXVECTOR3(MaxVXZ*2*Rand05(), MaxVY*Rand1(), MaxVXZ*2*Rand05());
	Vertex[0].Color=Vertex[1].Color=D3DXCOLOR(
		MinColor+Rand1()*(1-MinColor),
		MinColor+Rand1()*(1-MinColor),
		MinColor+Rand1()*(1-MinColor), 1);
}

// ړ
void CEachSpark::Move() {
	Vertex[0].Pos=Vertex[1].Pos;
	Vertex[1].Pos+=VPos;
	VPos.y+=APosY;
	if (Vertex[0].Pos.y<0) Init();
}

// `
void CEachSpark::Draw(LPDIRECT3DDEVICE9 device) {
	device->DrawPrimitiveUP(D3DPT_LINELIST, 1, Vertex, sizeof(SPARK_VERTEX));
}

void CEachSpark::DrawPoint(LPDIRECT3DDEVICE9 device) {
	device->DrawPrimitiveUP(D3DPT_POINTLIST, 1, Vertex, sizeof(SPARK_VERTEX));
}


//==============================================================
// ΉԂ̃f

// RXgN^
CSpark::CSpark(
	CMain* main, string title, int mode, 
	int spark_count, float max_vxz, float max_vy,
	float vyaw, D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), Mode(mode), 
	SparkCount(spark_count), 
	Yaw(0), VYaw(vyaw),
	From(from), Lookat(lookat)
{
	// bṼ[h
	Mesh=LoadMesh("SceneSword.x");

	// ΉԂ̍쐬
	Spark=new CEachSpark*[SparkCount];
	for (int i=0; i<SparkCount; i++) {
		if (Mode!=SPARK_NOINITLOOP) {
			Spark[i]=new CEachSpark(max_vxz, max_vy, 100);
		} else {
			Spark[i]=new CEachSpark(max_vxz, max_vy, 0);
		}
	}
}

// fXgN^
CSpark::~CSpark() {
	OnLostDevice();
	delete[] Spark;
}
	
// ړ
void CSpark::Move() {

	// V[̉]
	Yaw+=VYaw;

	// ΉԂ𓮂
	for (int i=0; i<SparkCount; i++) Spark[i]->Move();
}

// `
void CSpark::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &Lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(
		0, D3DLIGHT_POINT, 
		D3DXVECTOR3(-3, -5, -3), D3DXVECTOR3(0, 0, 0), 
		D3DXCOLOR(0.4f, 0.4f, 0.8f, 0), 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[̕`
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// ΉԂ̕`
	Device->SetFVF(D3DFVF_SPARK_VERTEX);
	Device->SetTexture(0, Main->GetDummyTexture());
	Device->SetRenderState(D3DRS_LIGHTING, FALSE);
	Device->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1);
	if (Mode!=SPARK_POINT) {
		for (int i=0; i<SparkCount; i++) Spark[i]->Draw(Device);
	} else {
		for (int i=0; i<SparkCount; i++) Spark[i]->DrawPoint(Device);
	}
	Device->SetRenderState(D3DRS_LIGHTING, TRUE);
}

