#include "Main.h"
#include "Stealth.h"


//==============================================================
// w

// RXgN^
CStealth::CStealth(CMain* main)
:	CDemo(main, "STEALTH"), 
	Time(0), Yaw(0), NormalScale(0)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneHorror_Obj.x");
	MeshEnv=LoadMesh("SceneHorror_Env.x");

	// GtFNg̃[h
	Effect=LoadEffect("Stealth.fx");
}

// fXgN^
CStealth::~CStealth() {
}
	
// ړ
void CStealth::Move() {
	Yaw+=0.01f;
	Time++;
	NormalScale=(sin(Time/60)+1)*2;
}

// `
void CStealth::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshEnv) { Error="MeshEnv"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 4, -8);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// eNX`ɔwi`
	SetRenderTarget(WorkTexture[0], OrgDepthStencil);
	Graphics->Clear(BGColor);
	MeshEnv->Draw();

	// ʂɃeNX``
	ResetRenderTarget();
	DrawTexture(WorkTexture[0], 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));

	// GtFNgKpĕ̂`
	D3DXMATRIX wv_proj;
	D3DXMatrixMultiply(&wv_proj, &world, &view);
	D3DXMatrixMultiply(&wv_proj, &wv_proj, &proj);
	Effect->SetMatrix("WVProj", &wv_proj);
	Effect->SetFloat("NormalScale", NormalScale);
	Effect->SetTexture("EnvTex", WorkTexture[0]);
	Effect->SetTechnique("Stealth");
	DrawMesh(MeshObj, Effect);
}

