#include "Main.h"
#include "TimePassage.h"

#define TABLE_COUNT 4


//==============================================================
// Ԃ̌o

// RXgN^
CTimePassage::CTimePassage(CMain* main, string title, float time, float vtime)
:	CDemo(main, title), Yaw(0.625f), Time(time), VTime(vtime)
{
	// bṼ[h
	Mesh=LoadMesh("SceneMahjong.x");

	// GtFNg̃[h
	Effect=LoadEffect("TimePassage.fx");
}

// fXgN^
CTimePassage::~CTimePassage() {
}
	
// ړ
void CTimePassage::Move() {
	Time+=VTime;
	if (Time>=TABLE_COUNT) Time-=TABLE_COUNT;
}

// `
void CTimePassage::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, D3DX_PI*2*Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 from(0, 3, -8);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &from, &lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	Effect->SetMatrix("Proj", &wv_proj);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// 
	D3DXVECTOR4 ambient(0.2f, 0.2f, 0.2f, 1);
	Effect->SetVector("Ambient", &ambient);

	// Cg̃e[u
	static D3DXVECTOR3 light_dir[]={
		D3DXVECTOR3(1, -0.4f, 1),
		D3DXVECTOR3(1, -1.0f, 1),
		D3DXVECTOR3(1, -0.4f, 1),
		D3DXVECTOR3(1,  0.4f, 1),
		D3DXVECTOR3(1, -0.4f, 1)
	};

	// Cg̕
	D3DXVECTOR3 ldir;
	D3DXVec3Lerp(&ldir, &light_dir[(int)floor(Time)], &light_dir[(int)ceil(Time)], Time-floor(Time));
	D3DXVec3Normalize(&ldir, &ldir);
	Effect->SetValue("LightDir", &ldir, sizeof(D3DXVECTOR3));

	// CgF̃e[u
	static D3DXVECTOR3 light_color[]={
		D3DXVECTOR3(0.6f, 0.7f, 0.8f),
		D3DXVECTOR3(1, 1, 1),
		D3DXVECTOR3(0.8f, 0.6f, 0.4f),
		D3DXVECTOR3(0.1f, 0.1f, 0.2f),
		D3DXVECTOR3(0.6f, 0.7f, 0.8f)
	};

	// Cg̐F
	D3DXVECTOR3 lcol;
	D3DXVec3Lerp(&lcol, &light_color[(int)floor(Time)], &light_color[(int)ceil(Time)], Time-floor(Time));
	Effect->SetValue("LightColor", &lcol, sizeof(D3DXVECTOR3));

	// V[̕`
	Graphics->Clear(BGColor);
	Effect->SetTechnique("TimePassage");
	DrawMesh(Mesh, Effect);
}

