#include "Main.h"
#include "TireTrack.h"


//==============================================================
// 1{̃^C

// RXgN^
CEachTireTrack::CEachTireTrack() 
:	State(0), Time(0), VertexCount(0)
{}

// ړ
void CEachTireTrack::Move(D3DXVECTOR3& p0, D3DXVECTOR3& p1) {
	TIRETRACK_VERTEX* v;
	float alpha;
	switch (State) {
		
		// 0F^CՂ
		case 0:

			// ̒_o^
			v=&Vertex[VertexCount+0];
			v->Pos=p0;
			v->Normal=D3DXVECTOR3(0, 1, 0);
			v->Color=D3DXCOLOR(0, 0, 0, 1);
			v->UV=D3DXVECTOR2(0, VertexCount*0.2f);

			// ̒_o^
			v=&Vertex[VertexCount+1];
			v->Pos=p1;
			v->Normal=D3DXVECTOR3(0, 1, 0);
			v->Color=D3DXCOLOR(0, 0, 0, 1);
			v->UV=D3DXVECTOR2(1, VertexCount*0.2f);

			// _̍XV
			VertexCount+=2;

			// _ɒB1
			if (VertexCount>=MAX_VERTEX_COUNT) {
				Time=0;
				State=1;
			}
			break;

		// 1F^CՂ񂾂
		case 1:
			
			// ^CՂ̖炾񂾂񔖂
			alpha=2.0f-Time/50.0f;
			for (int i=0; i<VertexCount; i++) {
				TIRETRACK_VERTEX* v=&Vertex[i];
				v->Color=D3DXCOLOR(0, 0, 0, 
					alpha+(float)(i-VertexCount)/VertexCount);
			}
			
			// Ԃ̍XV
			Time++;
			
			// SẴ^CՂď0ɖ߂
			if (Time>=100) {
				VertexCount=0;
				State=0;
			}
			break;
	}
}

// `
void CEachTireTrack::Draw(LPDIRECT3DDEVICE9 device, LPDIRECT3DTEXTURE9 texture) {
	
	// _tH[}bgƃeNX`̐ݒ
	device->SetFVF(D3DFVF_TIRETRACK_VERTEX);
	device->SetTexture(0, texture);

	// v~eBu̕`
	for (int i=0; i<VertexCount-2; i+=2) {
		device->DrawPrimitiveUP(
			D3DPT_TRIANGLESTRIP, 2, 
			&Vertex[i], sizeof(TIRETRACK_VERTEX));
	}
}


//==============================================================
// ^C

LPDIRECT3DTEXTURE9 CTireTrack::TireTrackTexture=NULL;

// RXgN^
CTireTrack::CTireTrack(CMain* main, string title, int track_count)
:	CDemo(main, title), 
	Yaw(0), TireTrackCount(track_count)
{
	// bṼ[h
	MeshObj=LoadMesh("SceneTrain_Obj.x");
	MeshEnv=LoadMesh("SceneTrain_Env.x");

	// eNX`̃[h
	TireTrackTexture=LoadTexture("TireTrack.png");

	// ^CՂ̃IuWFNg𐶐
	TireTrack=new CEachTireTrack[track_count];
}

// fXgN^
CTireTrack::~CTireTrack() {
	delete[] TireTrack;
}
	
// ړ
void CTireTrack::Move() {

	// ̂]
	Yaw+=0.03f;

	// ̂̑Ƀ^CՂ̐V_ǉ
	float
		c=cos(Yaw), s=-sin(Yaw), 
		x=c*3.0f, z=s*3.0f,
		dx=c*0.3f, dz=s*0.3f; 
	for (int i=0; i<TireTrackCount; i++) {
		float a=i*2+0.5f-TireTrackCount, b=a+1.0f;
		TireTrack[i].Move(
			D3DXVECTOR3(x+dx*a, TIRETRACK_Y, z+dz*a),
			D3DXVECTOR3(x+dx*b, TIRETRACK_Y, z+dz*b));
	}
}

// `
void CTireTrack::Draw() {

	// G[`FbN
	if (!MeshObj) { Error="MeshObj"; return; }
	if (!MeshObj) { Error="MeshEnv"; return; }
	if (!TireTrackTexture) { Error="TireTrackTexture"; return; }

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 from(0, 5, -10);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &from, &lookat, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// ̂̕`
	Graphics->Clear(BGColor);
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshObj->Draw();

	// wi̕`
	D3DXMatrixIdentity(&world);
	Device->SetTransform(D3DTS_WORLD, &world);
	MeshEnv->Draw();

	// ^CՂ̕`
	for (int i=0; i<TireTrackCount; i++) {
		TireTrack[i].Draw(Device, TireTrackTexture);
	}
}

