#include "Main.h"
#include "Toon.h"


//==============================================================
// gD[_O

// RXgN^
CToon::CToon(
	CMain* main, string title, string texture, 
	string technique, D3DXCOLOR ambient, 
	float ink_size, D3DXCOLOR ink_color
)
:	CDemo(main, title), Yaw(0),
	Technique(technique), Ambient(ambient), 
	InkSize(ink_size), InkColor(ink_color)
{
	// bṼ[h
	Mesh=LoadMesh("SceneMahjong.x");

	// GtFNg̃[h
	Effect=LoadEffect("Toon.fx");

	// gD[_OpeNX`̃[h
	ToonTex=LoadTexture(texture);
}

// fXgN^
CToon::~CToon() {
}
	
// ړ
void CToon::Move() {
	Yaw+=0.01f;
}

// `
void CToon::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }
	if (!ToonTex) { Error="ToonTex"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Effect->SetMatrix("World", &world);

	// [hr[s
	D3DXMATRIX w_view;
	D3DXVECTOR3 from(0, 2, -5.5f);
	D3DXVECTOR3 lookat(0, 1, 0);
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&w_view, &from, &lookat, &up);
	D3DXMatrixMultiply(&w_view, &world, &w_view);
	Effect->SetMatrix("WView", &w_view);
	
	// [hr[ˉes
	D3DXMATRIX wv_proj;
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMatrixPerspectiveLH(&wv_proj, 1, h/w, 1, 1000);
	D3DXMatrixMultiply(&wv_proj, &w_view, &wv_proj);
	Effect->SetMatrix("WVProj", &wv_proj);

	// Cg
	D3DXVECTOR4 light(1, -1, 1, 0);
	D3DXVec4Normalize(&light, &light);
	Effect->SetVector("Light", &light);
	
	// 
	Effect->SetVector("Ambient", (D3DXVECTOR4*)&Ambient);
	
	// gD[peNX`
	Effect->SetTexture("ToonTex", ToonTex);

	// CN̐FA
	Effect->SetVector("InkColor", (D3DXVECTOR4*)&InkColor);
	Effect->SetFloat("InkSize", InkSize);

	// eNjbN
	Effect->SetTechnique(Technique.c_str());

	// bV̕`iyCgj
	Graphics->Clear(BGColor);
	DrawMesh(Mesh, Effect);
}

