#include "Main.h"
#include "YIQ.h"


//==============================================================
// YIQFԂg

// RXgN^
CYIQ::CYIQ(
	CMain* main, string title, float i, float q, 
	string mesh, D3DXVECTOR3 from, D3DXVECTOR3 lookat
)
:	CDemo(main, title), I(i), Q(q), Yaw(0), From(from), LookAt(lookat)
{
	// bṼ[h
	Mesh=LoadMesh(mesh);

	// GtFNg̃[h
	Effect=LoadEffect("YIQ.fx");
}

// fXgN^
CYIQ::~CYIQ() {
}
	
// ړ
void CYIQ::Move() {
	Yaw+=0.01f;
}

// `
void CYIQ::Draw() {

	// G[`FbN
	if (!Mesh) { Error="Mesh"; return; }
	if (!Effect) { Error="Effect"; return; }

	// [hs
	D3DXMATRIX world;
	D3DXMatrixRotationY(&world, Yaw);
	Device->SetTransform(D3DTS_WORLD, &world);

	// r[s
	D3DXMATRIX view;
	D3DXVECTOR3 up(0, 1, 0);
	D3DXMatrixLookAtLH(&view, &From, &LookAt, &up);
	Device->SetTransform(D3DTS_VIEW, &view);
	
	// ˉes
	float w=Graphics->GetWidth(), h=Graphics->GetHeight();
	D3DXMATRIX proj;
	D3DXMatrixPerspectiveLH(&proj, 1, h/w, 1, 1000);
	Device->SetTransform(D3DTS_PROJECTION, &proj);

	// Cg
	Graphics->SetLight(0, D3DLIGHT_DIRECTIONAL, 1, -1, 1, 1000);

	// 
	D3DXCOLOR ambient(0.2f, 0.2f, 0.2f, 1);
	Device->SetRenderState(D3DRS_AMBIENT, ambient);

	// V[eNX`ɕ`悷
	SetRenderTarget(WorkTexture[0], WorkDepthStencil[0]);
	Graphics->Clear(BGColor);
	Mesh->Draw();

	// eNX`ʂɕ`悷
	ResetRenderTarget();
	Effect->SetTechnique("YIQ");
	if (!PS20()) Effect->SetTechnique("YIQ11");
	Effect->SetFloat("I", I);
	Effect->SetFloat("Q", Q);
	Effect->SetTexture("MeshTex", WorkTexture[0]);
	DrawRect(Effect, 0, 0, w, h, 0, 0, 1, 1, D3DXCOLOR(1, 1, 1, 1));
}

