#include "Font.h"


//==============================================================
// RXgN^
CFont::CFont(CImageGroup* ig)
:	ImageGroup(ig), Image(NULL)
{}

bool CFont::LoadFromFile(
	string file, CArchiveLoader* archive,
	string chars, int sw, int sh, float dw, float dh, 
	float shadex, float shadey
) {
	// TCYƍW̏
	SW=sw;
	SH=sh;
	DW=dw;
	DH=dh; 
	ShadeX=shadex;
	ShadeY=shadey;

	// 摜̍쐬ƃ[h
	Image=ImageGroup->NewImage(256, 256);
	if (!Image->LoadFromFile(file, archive)) return false;

	// e̍W̏
	int i, n, cn=256/SW;
	for (i=0; i<256; i++) X[i]=Y[i]=-1;
	for (i=0, n=chars.length(); i<n; i++) {
		unsigned int c=chars[i];
		X[c]=(i%cn)*SW;
		Y[c]=(i/cn)*SH;
	}
	return true;
}


//==============================================================
// `

// eȂ`ij
void CFont::DrawChar(
	unsigned char c, float x, float y, D3DCOLOR color
) {
	if (X[c]>=0 && Y[c]>=0) {
		Image->Draw(x, y, X[c], Y[c], SW, SH, color);
	}
}

// e`ij
void CFont::DrawChar(
	unsigned char c, float x, float y, D3DCOLOR color, D3DCOLOR shade
) {
	DrawChar(c, x+ShadeX, y+ShadeY, shade);
	DrawChar(c, x, y, color);
}

// eȂ`ij
void CFont::DrawText(
	string s, float x, float y, D3DCOLOR color
) {
	float dx=x;
	for (int i=0, n=s.length(); i<n; i++) {
		unsigned int c=s[i];
		if (X[c]>=0 && Y[c]>=0) {
			Image->Draw(dx, y, X[c], Y[c], SW, SH, color);
		}
		dx+=DW;
	}
}

// e`ij
void CFont::DrawText(
	string s, float x, float y, D3DCOLOR color, D3DCOLOR shade
) {
	DrawText(s, x+ShadeX, y+ShadeY, shade);
	DrawText(s, x, y, color);
}
