#include "Image.h"
#include <d3dx9.h>


//==============================================================
// _`

// Ǝ̒_`
struct IMAGE2D_VERTEX
{
	// ϊςݒ_
	FLOAT X, Y, Z, RHW;

	// fBt[YF
	D3DCOLOR Color;

	// eNX`W
	FLOAT TU, TV;
};

// Ǝ̒_`\FVF
#define D3DFVF_IMAGE2D_VERTEX (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)


//==============================================================
// 摜O[v

// V摜
CImage* CImageGroup::NewImage(int max_width, int max_height) {
	CImage* image=new CImage(this, max_width, max_height);
	Image.push_back(image);
	return image;
}

// RXgN^
CImageGroup::CImageGroup(
	LPDIRECT3DDEVICE9 device, int max_width, int max_height
)
:	Device(device), VertexBuffer(NULL), 
	ARGBSurface(NULL), XRGBSurface(NULL),
	MaxWidth(max_width), MaxHeight(max_height)
{
	// _obt@̍쐬
	Device->CreateVertexBuffer(
		5*sizeof(IMAGE2D_VERTEX), 0, D3DFVF_IMAGE2D_VERTEX, 
		D3DPOOL_MANAGED, &VertexBuffer, NULL);

	// T[tFX̍쐬
	int sw=((max_width+255)/256)*256,
		sh=((max_height+255)/256)*256;
	Device->CreateOffscreenPlainSurface(
		sw, sh, D3DFMT_A8R8G8B8, 
		D3DPOOL_SYSTEMMEM, &ARGBSurface, NULL);
	Device->CreateOffscreenPlainSurface(
		sw, sh, D3DFMT_X8R8G8B8, 
		D3DPOOL_SYSTEMMEM, &XRGBSurface, NULL);
}

// fXgN^
CImageGroup::~CImageGroup() {
	for (int i=0, n=Image.size(); i<n; i++) delete Image[i];
	if (VertexBuffer) VertexBuffer->Release();
	if (ARGBSurface) ARGBSurface->Release();
	if (XRGBSurface) XRGBSurface->Release();
}

// obNobt@̃TCY𓾂
static SIZE GetBackBufferSize(LPDIRECT3DDEVICE9 device) {
	LPDIRECT3DSURFACE9 back_buffer;
	D3DSURFACE_DESC desc;
	SIZE size={0, 0};
	if (SUCCEEDED(
		device->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &back_buffer)
	)) {
		if (SUCCEEDED(back_buffer->GetDesc(&desc))) {
			size.cx=desc.Width; size.cy=desc.Height;	
		}
		back_buffer->Release();
	}
	return size;
}

// foCXԂ̐ݒ
void CImageGroup::SetDeviceState() {

	// _O̐ݒ
	Device->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
	Device->SetRenderState(D3DRS_LIGHTING, FALSE);
	Device->SetRenderState(D3DRS_ZENABLE, FALSE);

	// At@ufBO̗L
	Device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

	// eNX`@̐ݒ
	Device->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
	Device->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	Device->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
	Device->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);

	// `ԂgȂ߂̐ݒ
	Device->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_POINT);
	Device->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_POINT);
	Device->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_POINT);

	// r[|[g
	D3DVIEWPORT9 viewport;
	SIZE size=GetBackBufferSize(Device);
	int w=size.cx, h=size.cy;
	viewport.X=0;
	viewport.Y=0;
	viewport.Width=w;
	viewport.Height=h;
	viewport.MinZ=0;
	viewport.MaxZ=1;
	Device->SetViewport(&viewport);
}

// `̕`
void CImageGroup::FillRect(float x, float y, float w, float h, D3DCOLOR color) {
	LPDIRECT3DDEVICE9 device=Device;
	LPDIRECT3DVERTEXBUFFER9 vbuffer=VertexBuffer;

	// _obt@foCXɐݒ
	device->SetStreamSource(0, vbuffer, 0, sizeof(IMAGE2D_VERTEX));
	device->SetFVF(D3DFVF_IMAGE2D_VERTEX);

	// _obt@̃bN
	IMAGE2D_VERTEX* v;
	if (SUCCEEDED(vbuffer->Lock(0, 4*sizeof(IMAGE2D_VERTEX), (void**)&v, 0)))
	{
		// _W̐ݒ
		v[0].X=x  ; v[0].Y=y;
		v[1].X=x+w; v[1].Y=y;
		v[2].X=x  ; v[2].Y=y+h;
		v[3].X=x+w; v[3].Y=y+h;

		// Z, RHW, _F̐ݒ
		for (int i=0; i<4; i++) {
			v[i].Z=0;
			v[i].RHW=1; 
			v[i].Color=color;
		}

		// _obt@̉CeNX`̑IC`
		vbuffer->Unlock();
		device->SetTexture(0, NULL);
		device->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	}
}

// `g̕`
void CImageGroup::FrameRect(float x, float y, float w, float h, D3DCOLOR color) {
	LPDIRECT3DDEVICE9 device=Device;
	LPDIRECT3DVERTEXBUFFER9 vbuffer=VertexBuffer;

	// _obt@foCXɐݒ
	device->SetStreamSource(0, vbuffer, 0, sizeof(IMAGE2D_VERTEX));
	device->SetFVF(D3DFVF_IMAGE2D_VERTEX);

	// _obt@̃bN
	IMAGE2D_VERTEX* v;
	if (SUCCEEDED(vbuffer->Lock(0, 5*sizeof(IMAGE2D_VERTEX), (void**)&v, 0)))
	{
		// _W̐ݒ
		v[0].X=x  ; v[0].Y=y;
		v[1].X=x+w; v[1].Y=y;
		v[2].X=x+w; v[2].Y=y+h;
		v[3].X=x  ; v[3].Y=y+h;
		v[4].X=x  ; v[4].Y=y;

		// Z, RHW, _F̐ݒ
		for (int i=0; i<4; i++) {
			v[i].Z=0;
			v[i].RHW=1; 
			v[i].Color=color;
		}

		// _obt@̉CeNX`̑IC`
		vbuffer->Unlock();
		device->SetTexture(0, NULL);
		device->DrawPrimitive(D3DPT_LINESTRIP, 0, 4);
	}
}


//==============================================================
// RXgN^CfXgN^

// RXgN^F
// eNX`쐬B
// w肳ꂽTCY傫Ȃ悤ɁC
// 256x256sNZ̃eNX`ׂB
CImage::CImage(
	CImageGroup* group, int max_width, int max_height
)
:	Group(group), 
	MaxWidth(max_width), MaxHeight(max_height),
	Width(0), Height(0)
{
	// eNX`̖
	XCount=(max_width+255)/256;
	YCount=(max_height+255)/256;

	// eNX`̍쐬
	Texture=new LPDIRECT3DTEXTURE9[XCount*YCount];
	for (int i=0, n=XCount*YCount; i<n; i++) {
		Texture[i]=NULL;
		Group->Device->CreateTexture(
			256, 256, 1, 0, 
			D3DFMT_A8R8G8B8, D3DPOOL_MANAGED,
			&Texture[i], NULL);
	}
}

// fXgN^F
// eNX`폜B
CImage::~CImage() {
	for (int i=0, n=XCount*YCount; i<n; i++) {
		if (Texture[i]) Texture[i]->Release();
	}
	delete[] Texture;
}


//==============================================================
// NA
void CImage::Clear(D3DCOLOR color) {
	D3DLOCKED_RECT tlr;
	for (int yc=0, i=0; yc<YCount; yc++) {
		for (int xc=0; xc<XCount; xc++, i++) {
			if (SUCCEEDED(Texture[i]->LockRect(0, &tlr, NULL, 0))) {
				for (int line=0; line<256; line++) {
					DWORD *tp=(DWORD*)((char*)tlr.pBits+tlr.Pitch*line);
					for (int col=0; col<256; col++) tp[col]=color;
				}
				Texture[i]->UnlockRect(0);
			}
		}
	}
}


//==============================================================
// `
void CImage::Draw(
	float dx, float dy, 
	int sx, int sy, int w, int h, 
	D3DCOLOR color,
	float wzoom, float hzoom, float turn,
	int alignx, int aligny
) {
	float cx=dx+(float)w/2, cy=dy+(float)h/2;
	D3DXMATRIX mat, tmp;
	D3DXMatrixTranslation(&mat, -cx, -cy, 0);
	D3DXMatrixScaling(&tmp, wzoom, hzoom, 0);
	D3DXMatrixMultiply(&mat, &mat, &tmp);
	D3DXMatrixRotationZ(&tmp, D3DX_PI*2*turn);
	D3DXMatrixMultiply(&mat, &mat, &tmp);
	D3DXMatrixTranslation(&tmp, cx, cy, 0);
	D3DXMatrixMultiply(&mat, &mat, &tmp);
	Draw(dx, dy, sx, sy, w, h, color, &mat, alignx, aligny);
}

// `i]TCYݒj
void CImage::Draw(
	float dx, float dy, float dw, float dh,
	int sx, int sy, int w, int h, 
	D3DCOLOR color
) {
	float cx=(float)dw/2, cy=(float)dh/2;
	D3DXMATRIX mat, tmp;
	D3DXMatrixTranslation(&mat, -cx, -cy, 0);
	D3DXMatrixScaling(&tmp, dw/w, dh/h, 0);
	D3DXMatrixMultiply(&mat, &mat, &tmp);
	D3DXMatrixTranslation(&tmp, cx, cy, 0);
	D3DXMatrixMultiply(&mat, &mat, &tmp);
	Draw(dx, dy, sx, sy, w, h, color, &mat, ALIGN_LEFT, ALIGN_TOP);
}

// `i}gNXj
void CImage::Draw(
	float dx, float dy,
	int sx, int sy, int w, int h,
	D3DCOLOR color,
	D3DXMATRIX* matrix,
	int alignx, int aligny
) {
	LPDIRECT3DDEVICE9 device=Group->Device;
	LPDIRECT3DVERTEXBUFFER9 vbuffer=Group->VertexBuffer;

	// _obt@foCXɐݒ
	device->SetStreamSource(
		0, vbuffer, 0, sizeof(IMAGE2D_VERTEX));
	device->SetFVF(D3DFVF_IMAGE2D_VERTEX);

	// 
	switch (alignx) {
		case 1: dx-=w/2; break;
		case 2: dx-=w; break;
	}
	switch (aligny) {
		case 1: dy-=h/2; break;
		case 2: dy-=h; break;
	}

	// 256x256̃eNX`^Cɕ~l߂
	int sl=sx, st=sy, sr=sx+w, sb=sy+h;
	for (int yc=0, i=0; yc<YCount; yc++) {
		for (int xc=0; xc<XCount; xc++, i++) {
			if (!Texture[i]) continue;

			// `悷^C̎l̍WvZF
			// ̃^Cɕ`Ώ۔͈͂Ȃ΁C
			// ̃^CɈڂB
			int l=xc*256, t=yc*256, r=l+256, b=t+256;
			if (r<=sl || sr<=l || b<=st || sb<=t) continue;

			// _obt@̃bN
			IMAGE2D_VERTEX* v;
			if (SUCCEEDED(vbuffer->Lock(
				0, 4*sizeof(IMAGE2D_VERTEX), 
				(void**)&v, 0))
			) {
				int j;

				// _WƃeNX`W̌vZF
				// ^C`Ώ۔͈͂̓ɂȂƂɂ́C
				// _WƃeNX`W𒲐B
				float 
					vl=(float)((l<sl)?sl-l:0), 
					vt=(float)((t<st)?st-t:0),
					vr=(float)((sr<r)?sr-l:256),
					vb=(float)((sb<b)?sb-t:256);
				float 
					tl=vl/256, tt=vt/256, 
					tr=vr/256, tb=vb/256;
				vl+=l+dx-sx; vr+=l+dx-sx;
				vt+=t+dy-sy; vb+=t+dy-sy;

				// eNX`W̐ݒ
				v[0].TU=tl; v[0].TV=tt;
				v[1].TU=tr; v[1].TV=tt;
				v[2].TU=tl; v[2].TV=tb;
				v[3].TU=tr; v[3].TV=tb;

				// }gNX̓Kp
				D3DXVECTOR2 v2[4];
				v2[0].x=vl; v2[0].y=vt;
				v2[1].x=vr; v2[1].y=vt;
				v2[2].x=vl; v2[2].y=vb;
				v2[3].x=vr; v2[3].y=vb;
				D3DXVECTOR4 v4;
				for (j=0; j<4; j++) {
					D3DXVec2Transform(&v4, &v2[j], matrix);
					v[j].X=v4.x;
					v[j].Y=v4.y;
				}

				// Z, RHW, _F̐ݒ
				for (j=0; j<4; j++) {
					v[j].Z=0; v[j].RHW=1; 
					v[j].Color=color;
				}

				// _obt@̉CeNX`̑IC`
				vbuffer->Unlock();
				device->SetTexture(0, Texture[i]);
				device->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
			}
		}
	}
}


//==============================================================
// 摜̃[hF
// 傫ȃT[tFCX쐬ĉ摜[hC
// 256x256sNZɕăeNX`ɃRs[B
// UpdateSurfaceStretchRect͎gȂ̂ŁC
// iD3DPOOL_DEFAULT̃eNX`ւ̃Rs[ɂ͎g邪C
// @̃NXłD3DPOOL_MANAGEDg߁Bj
// LockRectmemcpygăRs[B
bool CImage::LoadFromFile(string file, CArchiveLoader* archive) {
	LPDIRECT3DSURFACE9 surface=Group->ARGBSurface;

	D3DLOCKED_RECT slr;
	D3DXIMAGE_INFO info;
	if (archive) {
		ARCHIVE_ENTRY* e=archive->Find(file);
		if (!e || FAILED(D3DXLoadSurfaceFromFileInMemory(
			surface, NULL, NULL, e->Data, e->Size, NULL, 
			D3DX_FILTER_NONE, 0, &info))) return false;
	} else {
		if (FAILED(D3DXLoadSurfaceFromFile(
			surface, NULL, NULL, file.c_str(), NULL, 
			D3DX_FILTER_NONE, 0, &info))) return false;
	}
	if (SUCCEEDED(surface->LockRect(
		&slr, NULL, D3DLOCK_READONLY))
	) {
		Width=info.Width;
		Height=info.Height;
		for (int yc=0, i=0; yc<YCount; yc++) {
			for (int xc=0; xc<XCount; xc++, i++) {
				if (!Texture[i]) continue;
				D3DLOCKED_RECT tlr;
				if (SUCCEEDED(Texture[i]->LockRect(0, &tlr, NULL, 0))) {
					int x=xc*256, y=yc*256;
					for (int line=0; line<256; line++) {
						memcpy(
							(char*)tlr.pBits+tlr.Pitch*line, 
							(char*)slr.pBits+x*4+slr.Pitch*(y+line), 
							256*4);
					}
					Texture[i]->UnlockRect(0);
				}
			}
		}
		surface->UnlockRect();
	}
	return true;
}


//==============================================================
// eLXg̕`F
// eNX`ɃeLXg`߂ɁA
// GDIgăT[tFCXɃeLXg`A
// eNX`ɃRs[B
// T[tFCXɃAt@GDIgȂ̂ŁC
// iGetDCɎsj
// ̂悤ɖʓ|Ȏ菇ɂȂĂB
// T[tFCXeNX`ւ̃Rs[̍ۂɁC
// OŃeLXg̔wi悤ɃAt@ݒ肷B
void CImage::DrawText(
	const char* text, int x, int y, 
	D3DCOLOR color, HFONT font,
	ALIGN_TYPE halign, ALIGN_TYPE valign,
	SIZE* psize
) {
	LPDIRECT3DSURFACE9 surface=Group->XRGBSurface;

	// DC̎擾ƃtHg̐ݒ
	HDC hdc;
	if (SUCCEEDED(surface->GetDC(&hdc))) {
		HGDIOBJ prev_obj;
		if (font) prev_obj=SelectObject(hdc, font);

		// T[tFCX̍ɃeLXg`F
		// 𔒁Cwiŕ`B
		SetBkColor(hdc, 0x00000000);
		SetTextColor(hdc, 0x00ffffff);
		TextOut(hdc, 0, 0, text, strlen(text));

		// eLXg̕`͈͂𓾂
		SIZE size;
		if (!psize) psize=&size;
		GetTextExtentPoint32(
			hdc, text, strlen(text), psize);
		int w=psize->cx, h=psize->cy;

		// tHg̕ADC̉
		if (font) SelectObject(hdc, prev_obj);
		surface->ReleaseDC(hdc);
		if (w==0 || h==0) return;

		// eNX`̃eLXg̕\ʒu߂
		switch (halign) {
			case ALIGN_LEFT: break;
			case ALIGN_CENTER: x-=w/2; break;
			case ALIGN_RIGHT: x-=w; break;
		}
		switch (valign) {
			case ALIGN_TOP: break;
			case ALIGN_CENTER: y-=h/2; break;
			case ALIGN_BOTTOM: y-=h; break;
		}

		// T[tFCXeNX`̃^CɃRs[
		D3DLOCKED_RECT slr;
		RECT sdr={0, 0, w, h};
		if (SUCCEEDED(surface->LockRect(
				&slr, &sdr, D3DLOCK_READONLY))
		) {
			int ca=color>>24&0xff, crgb=color&0x00ffffff;
			int sl=x, st=y, sr=sl+w, sb=st+h;
			for (int yc=0, i=0; yc<YCount; yc++) {
				for (int xc=0; xc<XCount; xc++, i++) {
					if (!Texture[i]) continue;

					// eLXg`͈͂^C͈̔͊ÔƂɂ
					// `悵Ȃ
					int tl=xc*256, tt=yc*256, tr=tl+256, tb=tt+256;
					if (tr<=sl || sr<=tl || tb<=st || sb<=tt) continue;

					// eLXg̔wi悤ɃRs[F
					// CwiȂ̂ŁC
					// rbgZgăAt@lݒ肷B
					// eLXg̕bN悤ɂB
					// eNX`ŜbNƂƂĂxȂB
					int 
						dl=(tl<sl)?sl-tl:0,
						dt=(tt<st)?st-tt:0,
						dr=(sr<tr)?sr-tl:256,
						db=(sb<tb)?sb-tt:256;
					RECT tdr={dl, dt, dr, db};
					D3DLOCKED_RECT tlr;
					if (SUCCEEDED(Texture[i]->LockRect(0, &tlr, &tdr, 0))) {
						int dw=dr-dl, dh=db-dt;
						for (int line=0; line<dh; line++) {

							// eNX`ƃT[tFCX̃AhXvZF
							// eNX`͕ύẌ̂݃bNĂ邽߁A
							// tlr.pBits͕ύẌ̍wĂB
							DWORD *tp=(DWORD*)((char*)tlr.pBits+
								tlr.Pitch*line);
							DWORD *sp=(DWORD*)((char*)slr.pBits+
								(tl+dl-x)*4+slr.Pitch*(tt+dt-y+line));
							
							for (int col=0; col<dw; col++) {

								// BAt@ɐݒ肵C
								// RGB͎w肳ꂽFɂB
								// A`GCAXAt@ŕ\邽߁B
								int a=ca*(sp[col]&0xff)/0xff;
								if (a) tp[col]=a<<24|crgb;

								/*
								// ClearTypeɑΉ@Ă݂C
								// tHg쐬ɒʏ̃A`GCAX
								// w肵ǂʂɂȂB
								DWORD c=sp[col], r=c>>16&255, 
									g=c>>8&255, b=c&255;
								DWORD a=(r+g+b)/3;
								tp[col]=a<<24|color;
								*/

							}
						}
						Texture[i]->UnlockRect(0);
					}
				}
			}
			surface->UnlockRect();
		}
	}
}





