#ifndef IMAGEH
#define IMAGEH

#include "..\LibUtil\Archive.h"
#include <d3dx9.h>
#include <vector>
#include <string>
using namespace std;

class CImage;
class CImageGroup;


//==============================================================
// }N
inline int ARGB(int a, int r, int g, int b) {
	return ((a&255)<<24 | (r&255)<<16 |
		(g&255)<<8 | (b&255));
}
inline DWORD ARGB_A(DWORD rgb) { return (rgb)>>24&255; }
inline DWORD ARGB_R(DWORD rgb) { return (rgb)>>16&255; }
inline DWORD ARGB_G(DWORD rgb) { return (rgb)>>8&255; }
inline DWORD ARGB_B(DWORD rgb) { return rgb&255; }


//==============================================================
// 
typedef enum {
	ALIGN_CENTER,
	ALIGN_LEFT, ALIGN_RIGHT,
	ALIGN_TOP, ALIGN_BOTTOM	
} ALIGN_TYPE;


//==============================================================
// 摜
class CImage {
friend class CImageGroup;

protected:

	// O[v
	CImageGroup* Group;

	// eNX`
	LPDIRECT3DTEXTURE9* Texture;

	// 摜̕CCő啝Cő卂CeNX`iXCYj
	int Width, Height, MaxWidth, MaxHeight, XCount, YCount;

	// RXgN^CfXgN^
	CImage(CImageGroup* group, int max_width, int max_height);
	~CImage();

public:

	// 傫
	int GetMaxWidth() { return MaxWidth; }
	int GetMaxHeight() { return MaxHeight; }
	int GetWidth() { return Width; }
	int GetHeight() { return Height; }

	// 摜t@C̃[h
	bool LoadFromFile(string file, CArchiveLoader* archive=NULL);

	// `i}gNXj
	void Draw(
		float dx, float dy,
		int sx, int sy, int w, int h,
		D3DCOLOR color,
		D3DXMATRIX* matrix,
		int alignx, int aligny
	);

	// `i}gNXj
	void Draw(
		float dx, float dy,
		D3DCOLOR color,
		D3DXMATRIX* matrix,
		int alignx, int aligny
	) {
		Draw(dx, dy, 0, 0, Width, Height, color, matrix, alignx, aligny);
	}

	// `iS@\j
	void Draw(
		float dx, float dy, 
		int sx, int sy, int w, int h, 
		D3DCOLOR color,
		float wzoom, float hzoom, float turn,
		int alignx, int aligny
	);		

	// `i摜Śj
	void Draw(
		float dx, float dy, 
		D3DCOLOR color,
		float wzoom, float hzoom, float turn,
		int alignx, int aligny
	) {
		Draw(dx, dy, 0, 0, Width, Height, color, wzoom, hzoom, turn, alignx, aligny);
	}

	// `i]TCYݒj
	void Draw(
		float dx, float dy, float dw, float dh,
		int sx, int sy, int w, int h, 
		D3DCOLOR color
	);

	// `i]TCYݒC摜Śj
	void Draw(
		float dx, float dy, float dw, float dh,
		D3DCOLOR color
	) {
		Draw(dx, dy, dw, dh, 0, 0, Width, Height, color);
	}

	// `igk]Ȃj
	void Draw(
		float dx, float dy, 
		int sx, int sy, int w, int h, 
		D3DCOLOR color
	) {
		Draw(dx, dy, sx, sy, w, h, color, 1, 1, 0, 0, 0);
	}

	// `i摜ŚCgk]Ȃj
	void Draw(
		float dx, float dy, 
		D3DCOLOR color
	) {
		Draw(dx, dy, 0, 0, Width, Height, color, 1, 1, 0, 0, 0);
	}

	// `i摜ŚCgk]ȂCʍjF
	void Draw() {
		Draw(0, 0, 0, 0, Width, Height, 0xffffffff, 1, 1, 0, 0, 0);
	}

	// NA
	void Clear(D3DCOLOR color=D3DCOLOR_ARGB(0, 0, 0, 0));

	// eLXg
	void DrawText(
		const char* text, int x, int y, 
		D3DCOLOR color, HFONT font,
		ALIGN_TYPE halign=ALIGN_LEFT, 
		ALIGN_TYPE valign=ALIGN_TOP,
		SIZE* psize=NULL
	);

};


//==============================================================
// 摜O[v
class CImageGroup {
friend class CImage;

protected:

	// Direct3DfoCXC_obt@
	LPDIRECT3DDEVICE9 Device;
	LPDIRECT3DVERTEXBUFFER9 VertexBuffer;

	// ƗpT[tFCXCTCY
	LPDIRECT3DSURFACE9 ARGBSurface, XRGBSurface;
	int MaxWidth, MaxHeight;

	// 摜
	vector<CImage*> Image;

public:

	// 傫
	int GetMaxWidth() { return MaxWidth; }
	int GetMaxHeight() { return MaxHeight; }

	// RXgN^CfXgN^
	CImageGroup(LPDIRECT3DDEVICE9 device, int max_width, int max_height);
	~CImageGroup();

	// V摜
	CImage* NewImage(int max_width, int max_height);
	CImage* NewImage() { return NewImage(MaxWidth, MaxHeight); }

	// `
	void FillRect(float x, float y, float w, float h, D3DCOLOR color);
	void FrameRect(float x, float y, float w, float h, D3DCOLOR color); 

	// foCXԂ̐ݒ
	void SetDeviceState();

};


#endif

