#include "Music.h"

#include <windows.h>
#include <cguid.h>
#include <math.h>


// W̃RXgN^p[^iyCʉj
const CMUSIC_PARAM 
	*CMUSIC_PARAM_MUSIC=new CMUSIC_PARAM(false, 64), 
	*CMUSIC_PARAM_SOUND=new CMUSIC_PARAM(true, 1);


//==============================================================
// RXgN^CfXgN^

// RXgN^
CMusic::CMusic(const CMUSIC_PARAM* param)
:	Loader(NULL), Performance(NULL), 
	AudioPath(NULL), DS3DBuffer(NULL),
	Segment(NULL)
{
	// COM̏CLoader̍쐬CPerformance̍쐬
	CoInitialize(NULL);
	CoCreateInstance(
		CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicLoader8, (void**)&Loader);
	CoCreateInstance(
		CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicPerformance8, (void**)&Performance);

	// PerformancȅCAudioPath̎擾
	if (!Performance) return;
	Performance->InitAudio(
		NULL, NULL, NULL, 
		param->Use3D?DMUS_APATH_DYNAMIC_3D:DMUS_APATH_DYNAMIC_STEREO,
		param->NumChannels,
		DMUS_AUDIOF_ALL, NULL);
	Performance->GetDefaultAudioPath(&AudioPath);
	
	// DirectSound3Dobt@̎擾
	if (!AudioPath) return;
	if (param->Use3D) {
		AudioPath->GetObjectInPath(
			DMUS_PCHANNEL_ALL, DMUS_PATH_BUFFER, 0, 
			GUID_NULL, 0, IID_IDirectSound3DBuffer, 
			(LPVOID*)&DS3DBuffer);
	}
}

// fXgN^
CMusic::~CMusic()
{
	if (DS3DBuffer) DS3DBuffer->Release();
	if (Segment) Segment->Release();
	if (Performance) {
		Performance->CloseDown();
		Performance->Release();
	}
	
	if (Loader) Loader->Release(); 
	CoUninitialize();	
}


//==============================================================
// ݒC[h

// pX̐ݒ
void CMusic::SetSearchDir(string dir) {
	if (!Loader) return;
	WCHAR wc_dir[MAX_PATH+1];
	if (!MultiByteToWideChar(
		CP_ACP, 0, dir.c_str(), -1, wc_dir, MAX_PATH)) return;
	wc_dir[MAX_PATH]=0;
	Loader->SetSearchDirectory(
		GUID_DirectMusicAllTypes, wc_dir, FALSE);
}

// t@C̃[h
void CMusic::LoadFromFile(string file) {
	if (!Loader || !Performance) return;
	
	// t@C̉H
	WCHAR wc_file[MAX_PATH+1];
	if (!MultiByteToWideChar(
		CP_ACP, 0, file.c_str(), -1, wc_file, MAX_PATH)) return;
	
	// Âf[^̔p
	if (Segment) {
		Segment->Unload(Performance);
		Segment->Release();
		Segment=NULL;
	}
	Loader->CollectGarbage();
	
	// Vf[^̃[h
	Loader->LoadObjectFromFile(
		CLSID_DirectMusicSegment, IID_IDirectMusicSegment8,
		wc_file, (LPVOID*)&Segment);
	if (Segment) Segment->Download(Performance);
}

// 3DԂɂĐʒu̐ݒ
void CMusic::SetXYZ(float x, float y, float z) {
	if (!DS3DBuffer) return;
	DS3DBuffer->SetPosition(x, y, z, DS3D_IMMEDIATE );
}

// {[̐ݒi0.0`1.0j
void CMusic::SetVolume(float volume) {
	if (!AudioPath) return;
	volume=100*20*log10(volume);
	long v=0;
	if (volume<-9600) v=-9600; else 
		if (volume>0) v=0; else v=(long)volume;
	AudioPath->SetVolume(v, 0);
}


//==============================================================
// ĐC~

// Đ
void CMusic::Play(int loops) {
	if (!Segment || !Performance || !AudioPath) return;
	DWORD repeats=
		loops<0 ? DMUS_SEG_REPEAT_INFINITE : 
		loops>0 ? (DWORD)loops-1 : 0;
	Segment->SetRepeats(repeats);
	Performance->PlaySegmentEx(
		Segment, NULL, NULL, DMUS_SEGF_SECONDARY, 
		0, NULL, NULL, AudioPath);
}

// ~
void CMusic::Stop() {
	if (!Performance) return;
	Performance->Stop(NULL, NULL, 0, 0);
}

// Đǂ
bool CMusic::IsPlaying() {
	return Performance->IsPlaying(Segment, NULL)==S_OK;
}



