#ifndef LIBGAME_MUSICH
#define LIBGAME_MUSICH

#include <dmusicc.h>
#include <dmusici.h>
#include <vector>
#include <string>
using namespace std;


// RXgN^̃p[^
class CMUSIC_PARAM {
public:
	bool Use3D;
	int NumChannels;
	CMUSIC_PARAM(bool use3d, int num_channels)
	:	Use3D(use3d), NumChannels(num_channels) {}
	CMUSIC_PARAM()
	:	Use3D(false), NumChannels(64) {}
};
extern const CMUSIC_PARAM *CMUSIC_PARAM_MUSIC, *CMUSIC_PARAM_SOUND;


// yʉĐ̃NX
class CMusic {
protected:

	IDirectMusicLoader8* Loader;
	IDirectMusicPerformance8* Performance;
	IDirectMusicAudioPath8* AudioPath;
	IDirectSound3DBuffer8* DS3DBuffer;
	IDirectMusicSegment8* Segment;

public:

	CMusic(const CMUSIC_PARAM* param);
	~CMusic();

	void SetSearchDir(string dir);
	void LoadFromFile(string file);
	void SetXYZ(float x, float y, float z);
	void SetVolume(float volume);

	bool IsPlaying();
	void Play(int repeats);
	void Play() { Play(0); }
	void Loop() { Play(-1); }
	void Stop();

};


#endif
