#include "Show.h"
#include <stdlib.h>


//==============================================================
// RXgN^
CShow::CShow()
:	Graph(NULL), Control(NULL), Event(NULL), 
	Seeking(NULL), Audio(NULL)
{
	// COMCȕ
	CoInitialize(NULL);
}


//==========================================================
// fXgN^
CShow::~CShow() {
	CleanUp();
	CoUninitialize();
}


//==========================================================
// 擾̉
void CShow::CleanUp() {
	if (Seeking) { Seeking->Release(); Seeking=NULL; }
	if (Event)   { Event->Release();   Event=NULL;   }
	if (Control) { Control->Release(); Control=NULL; }
	if (Graph)   { Graph->Release();   Graph=NULL;   }
	if (Audio)   { Audio->Release();   Audio=NULL;   }
}


//==============================================================
// t@C̃[h
bool CShow::Load(string file_name) {

	// ̉
	CleanUp();

	// C^[tFCX̎擾
	// iGraphBuilderCMediaControlCMediaEventCMediaSeekingj
	if (FAILED(CoCreateInstance(
			CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, 
			IID_IGraphBuilder, (void **)&Graph)) ||
		FAILED(Graph->QueryInterface(
			IID_IMediaControl, (void **)&Control)) ||
		FAILED(Graph->QueryInterface(
			IID_IMediaEvent, (void **)&Event)) ||
		FAILED(Graph->QueryInterface(
			IID_IMediaSeeking, (void **)&Seeking)) ||
		FAILED(Graph->QueryInterface(
			IID_IBasicAudio, (void **)&Audio))
	) return false;
	
	// t@CUnicodeɕϊF
	// mbstowcs֐ł͂܂ȂB
	wchar_t fn[MAX_PATH];
	MultiByteToWideChar(
		0, 0, file_name.c_str(), -1, fn, MAX_PATH);

	// Ot̍쐬Ǝs
	if (FAILED(Graph->RenderFile(fn, NULL))) return false;

	return true;
}


//==============================================================
// ~
void CShow::Stop() {
	if (!Control) return;
	Control->Stop();
	SetPos(0);
}


//==============================================================
// ĐCꎞ~

// Đ
void CShow::Play() {
	if (!Control) return;
	Control->Run();
}

// ꎞ~
void CShow::Pause() {
	if (!Control) return;
	Control->Pause();
}


//==============================================================
// ĐIǂ
bool CShow::IsFinished() {
	if (!Event) return true;
	long code;
	return SUCCEEDED(Event->WaitForCompletion(0, &code));
}


//==============================================================
// Đ̈ʒuCŜ̒ibPʁj
float CShow::GetPos() {
	if (!Seeking) return 0;
	LONGLONG current, length;
	Seeking->GetPositions(&current, &length);
	double d=(double)current;
	return (float)(d/10000000);
}

float CShow::GetLength() {
	if (!Seeking) return 0;
	LONGLONG current, length;
	Seeking->GetPositions(&current, &length);
	double d=(double)length;
	return (float)(d/10000000);
}

//==============================================================
// Đʒu̕ύX

// Έʒu
void CShow::SetPos(float pos) {
	if (!Seeking) return;
	LONGLONG current=(LONGLONG)((double)pos*10000000);
	Seeking->SetPositions(
		&current, AM_SEEKING_AbsolutePositioning,
		NULL, AM_SEEKING_NoPositioning);
}

// Έʒu
void CShow::MovePos(float offset) {
	SetPos(GetPos()+offset);
}

//==============================================================
// {[i0.0`1.0j

float CShow::GetVolume() {
	long l;
	Audio->get_Volume(&l);
	return ((float)l+10000)/10000;
}

void CShow::SetVolume(float vol) {
	long l=(long)(vol*10000-10000);
	if (l<-10000) l=-10000; else if (l>0) l=0;
	Audio->put_Volume(l);
}

//==============================================================
// oXi-1.0`1.0j

float CShow::GetBalance() {
	long l;
	Audio->get_Balance(&l);
	return (float)l/10000;
}

void CShow::SetBalance(float bal) {
	long l=(long)(bal*10000);
	if (l<-10000) l=-10000; else if (l>10000) l=10000;
	Audio->put_Balance(l);
}


