#include "Sound.h"
#include "..\LibUtil\LibUtil.h"
#include <windows.h>
#include <cguid.h>
#include <math.h>


//==============================================================
// TEh֘A̋ʃf[^
class CSoundCommon {
public:
	IDirectMusicLoader8* Loader;
	class CSoundPlayer* DefaultSoundPlayer;
	unsigned int NumSounds;
	CSoundCommon();
	~CSoundCommon();
};
static CSoundCommon* SoundCommon=NULL;

// RXgN^
CSoundCommon::CSoundCommon()
:	Loader(NULL), NumSounds(0), DefaultSoundPlayer(NULL)
{
	CoInitialize(NULL);
	CoCreateInstance(
		CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicLoader8, (void**)&Loader);
	DefaultSoundPlayer=new CSoundPlayer();
}

// ʃf[^̃fXgN^
CSoundCommon::~CSoundCommon() {
	delete DefaultSoundPlayer;
	if (Loader) Loader->Release();
	CoUninitialize();
}


//==============================================================
// ʉf[^̃NX

// RXgN^
CSound::CSound() 
:	Segment(NULL), MemData(NULL)
{
	if (!SoundCommon) SoundCommon=new CSoundCommon();
	SoundCommon->NumSounds++;
}

// fXgN^
CSound::~CSound()
{
	// ZOg̉
	if (Segment) Segment->Release();
	if (MemData) delete[] MemData;
	
	// [_[̍폜
	SoundCommon->NumSounds--;
	if (!SoundCommon->NumSounds) {
		delete SoundCommon;
		SoundCommon=NULL;
	}
}

// [h
bool CSound::LoadFromFile(string file, CArchiveLoader* archive) {

	// [_[̊mF
	if (!SoundCommon->Loader) return false;

	// ZOg̉
	if (Segment) {
		Segment->Release();
		Segment=NULL;
	}
	if (MemData) {
		delete[] MemData;
		MemData=NULL;
	}

	// t@C̉H
	WCHAR wc_file[MAX_PATH+1];
	if (!MultiByteToWideChar(
		CP_ACP, 0, file.c_str(), -1, wc_file, MAX_PATH)) return false;
	
	// f[^̃[h
	if (archive) {
		ARCHIVE_ENTRY* e=archive->Find(file);
		if (!e) return false;
		
		// GetObjectɂ͈ꎞ̈nƂłȂ߁A
		// ̈mۂăf[^Rs[
		MemData=new BYTE[e->Size];
		memcpy(MemData, e->Data, e->Size);
		
		DMUS_OBJECTDESC desc;
		desc.dwSize=sizeof(DMUS_OBJECTDESC);
		desc.guidClass=CLSID_DirectMusicSegment;
		desc.dwValidData=DMUS_OBJ_CLASS|DMUS_OBJ_MEMORY;
		desc.pbMemData=MemData;
		desc.llMemLength=e->Size;
		if (FAILED(SoundCommon->Loader->GetObject(
			&desc, IID_IDirectMusicSegment8,
			(LPVOID*)&Segment))) return false;
	} else {
		if (FAILED(SoundCommon->Loader->LoadObjectFromFile(
			CLSID_DirectMusicSegment, IID_IDirectMusicSegment8,
			wc_file, (LPVOID*)&Segment))) return false;
	}
	return true;
}

// Đ񐔂̐ݒ
void CSound::SetRepeats(unsigned int repeats) {
	if (!Segment) return;
	repeats=
		repeats<0 ? DMUS_SEG_REPEAT_INFINITE : 
		repeats>0 ? (DWORD)repeats-1 : 0;
	Segment->SetRepeats(repeats);	
}

// ĐA~
bool CSound::IsPlaying() { return SoundCommon->DefaultSoundPlayer->IsPlaying(this); }
void CSound::Play() { SoundCommon->DefaultSoundPlayer->Play(this); }
void CSound::Stop() { SoundCommon->DefaultSoundPlayer->Stop(this); }


//==============================================================
// ʉĐ̃NX

// RXgN^̋ʏ
void CSoundPlayer::Construct(bool use3d, int channels) {
	Performance=NULL;
	AudioPath=NULL;
	DS3DBuffer=NULL;

	// ptH[}X̍쐬
	CoCreateInstance(
		CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, 
		IID_IDirectMusicPerformance8, (void**)&Performance);

	// ptH[}X̏AI[fBIpX̎擾
	if (!Performance) return;
	Performance->InitAudio(
		NULL, NULL, NULL, 
		use3d?DMUS_APATH_DYNAMIC_3D:DMUS_APATH_DYNAMIC_STEREO,
		channels,
		DMUS_AUDIOF_ALL, NULL);
	Performance->GetDefaultAudioPath(&AudioPath);
	
	// DirectSound3Dobt@̎擾
	if (!AudioPath) return;
	if (use3d) {
		AudioPath->GetObjectInPath(
			DMUS_PCHANNEL_ALL, DMUS_PATH_BUFFER, 0, 
			GUID_NULL, 0, IID_IDirectSound3DBuffer, 
			(LPVOID*)&DS3DBuffer);
	}
}

// fXgN^
CSoundPlayer::~CSoundPlayer()
{
	if (DS3DBuffer) DS3DBuffer->Release();
	if (Performance) {
		Performance->CloseDown();
		Performance->Release();
	}
}

// 3DԂɂĐʒu̐ݒ
void CSoundPlayer::Set3DPosition(float x, float y, float z) {
	if (!DS3DBuffer) return;
	DS3DBuffer->SetPosition(x, y, z, DS3D_IMMEDIATE );
}

// {[̐ݒi0.0`1.0j
void CSoundPlayer::SetVolume(float volume) {
	if (!AudioPath) return;
	volume=100*20*log10(volume);
	long v=0;
	
	if (volume<-9600) v=-9600; else if (volume>0) v=0; else v=(long)volume;
	AudioPath->SetVolume(v, 0);
}

// Đ
void CSoundPlayer::Play(CSound* sound) {
	if (!sound->Segment || !Performance || !AudioPath) return;
	sound->Segment->Download(Performance);
	Performance->PlaySegmentEx(
		sound->Segment, NULL, NULL, DMUS_SEGF_SECONDARY, 
		0, NULL, NULL, AudioPath);
}

// ~
void CSoundPlayer::Stop(CSound* sound) {
	if (!Performance) return;
	Performance->Stop(sound->Segment, NULL, 0, 0);
}

// Đǂ
bool CSoundPlayer::IsPlaying(CSound* sound) {
	if (!Performance) return false;
	return Performance->IsPlaying(sound->Segment, NULL)==S_OK;
}

