#ifndef LIBGAME_SOUNDH
#define LIBGAME_SOUNDH

#include "..\LibUtil\Archive.h"
#include <dmusicc.h>
#include <dmusici.h>
#include <vector>
#include <string>
using namespace std;


// ʉf[^̃NX
class CSound {
friend class CSoundPlayer;
protected:

	IDirectMusicSegment8* Segment;
	BYTE* MemData;

public:

	CSound();
	~CSound();
	bool LoadFromFile(string file, CArchiveLoader* archive=NULL);
	void SetRepeats(unsigned int repeats);
	bool IsPlaying();
	void Play();
	void Stop();

};


// ʉĐ̃NX
class CSoundPlayer {
protected:

	IDirectMusicPerformance8* Performance;
	IDirectMusicAudioPath8* AudioPath;
	IDirectSound3DBuffer8* DS3DBuffer;

	void Construct(bool use3d, int num_channels);

public:

	CSoundPlayer(bool use3d, int channels) { Construct(use3d, channels); }
	CSoundPlayer() { Construct(true, 1); }
	~CSoundPlayer();

	void LoadFromFile(string file);
	void Set3DPosition(float x, float y, float z);
	void SetVolume(float volume);

	bool IsPlaying(CSound* sound);
	void Play(CSound* sound);
	void Stop(CSound* sound=NULL);

};


#endif
