#include "Task.h"
#include <stdio.h>
#include <assert.h>


//=============================================================
// ^XNXg̏
CTaskList::CTaskList(int max_task_size, int max_num_task)
:	MaxTaskSize(max_task_size), MaxNumTask(max_num_task), 
	NumFreeTask(max_num_task)
{
	// ^XNp̃}N
	#define TASK(INDEX) ((CTask*)(buf+max_task_size*(INDEX)))

	// ^XNp̊m
	char* buf=new char[max_task_size*(max_num_task+2)];

	// ANeBu^XNXg̏
	ActiveTask=TASK(0);
	ActiveTask->Prev=ActiveTask->Next=ActiveTask;

	// t[^XNXg̏
	FreeTask=TASK(1);
	for (int i=1; i<max_num_task+1; i++) {
		TASK(i)->Next=TASK(i+1);
	}
	TASK(max_num_task+1)->Next=FreeTask;
}


//=============================================================
// ^XN̐
// t[^XNXgł́AubN̐擪CTaskzuB
// TuNX̃RXgN^Ăяoɂ́A
// ubN̐擪CTaskzuƂ͌ȂidpȂǁj
// ŁAnewƃRXgN^ɕB
// 폜lɃfXgN^deleteɕB

// new̏
void* CTask::operator_new(size_t t, CTaskList* task_list) {

	// NXTCYőTCY𒴂G[
	assert(t<=(size_t)task_list->MaxTaskSize);

	// t[^XNȂƂNULLԂ
	if (task_list->NumFreeTask<=0) return NULL;

	// t[^XN1o
	CTask* task=task_list->FreeTask->Next;
	task_list->FreeTask->Next=task->Next;
	task_list->NumFreeTask--;
	
	// RXgN^
	return task;
}

// RXgN^
CTask::CTask(CTaskList* task_list)
:	TaskList(task_list)
{

	// ^XNANeBu^XNXgɑ}
	Prev=task_list->ActiveTask->Prev;
	Next=task_list->ActiveTask;
	Prev->Next=Next->Prev=this;
}


//=============================================================
// ^XN̍폜

// fXgN^
CTask::~CTask() {

	// ^XNANeBu^XNXg폜
	Prev->Next=Next;
	Next->Prev=Prev;
}

// deletȅ
void CTask::operator_delete(void* p, CTaskList* task_list) {

	// ^XN
	CTask* task=(CTask*)p;

	// ^XNt[^XNXgɑ}
	task->Next=task_list->FreeTask->Next;
	task_list->FreeTask->Next=task;
	task_list->NumFreeTask++;

	// t[^XNő^XN𒴂G[
	// ideletȅdĂяoȂǁj
	assert(task_list->NumFreeTask<=task_list->MaxNumTask);
}


//=============================================================
// S^XN̏
void CTaskList::DeleteTask() {
	for (CTaskIter i(this); i.HasNext(); i.Next(), i.Remove()) ;
}
