#ifndef TEXTUREH
#define TEXTUREH

#include <d3dx9.h>
#include <vector>
#include <string>
using namespace std;

class CTexture;
class CTextureGroup;


//==============================================================
// eNX`
class CTexture {
friend class CTextureGroup;

protected:

	// O[v
	CTextureGroup* Group;

	// eNX`
	LPDIRECT3DTEXTURE9 Texture;

	// TCY
	int W, H;

public:

	// RXgN^AfXgN^
	CTexture(CTextureGroup* group, int w, int h);
	~CTexture();

	// TCY
	int GetWidth() { return W; }
	int GetHeight() { return H; }

	// eNX`
	LPDIRECT3DTEXTURE9 GetTexture() { return Texture; }

	// 摜t@C̃[h
	void LoadFromFile(string file_name);

	// `
	void Draw(
		float x0, float y0, float x1, float y1, 
		float u0, float v0, float u1, float v1, 
		D3DCOLOR diffuse
	);

	// hԂ
	void Fill(D3DXVECTOR4* color);
};


//==============================================================
// eNX`O[v
class CTextureGroup {
friend class CTexture;

protected:

	// Direct3DfoCX
	LPDIRECT3DDEVICE9 Device;

	// _obt@A[xobt@
	LPDIRECT3DVERTEXBUFFER9 VertexBuffer;
	LPDIRECT3DSURFACE9 DepthBuffer;

	// TCY
	int MaxW, MaxH;

	// eNX`
	vector<CTexture*> Texture;

public:

	// RXgN^CfXgN^
	CTextureGroup(LPDIRECT3DDEVICE9 device, int max_w, int max_h);
	~CTextureGroup();

	// 傫
	int GetMaxWidth() { return MaxW; }
	int GetMaxHeight() { return MaxH; }
};


#endif

