#include "Archive.h"
#include "Util.h"
#include <assert.h>

// fXgN^iZ[uj
CArchiveSaver::~CArchiveSaver() {
	for (size_t i=0, n=Entry.size(); i<n; i++) {
		delete[] Entry[i].Data;
	}
}

// Gg̒ǉ
void CArchiveSaver::Add(string name) {
	
	// Ggt@CJ
	HANDLE h=CreateFile(
		name.c_str(), GENERIC_READ, FILE_SHARE_READ, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (h!=INVALID_HANDLE_VALUE) {

		// TCY𒲂ׂ
		DWORD size=GetFileSize(h, NULL);
		char* data=new char[size];
		
		// Ggt@Cǂݍ
		DWORD nbytes;
		ReadFile(h, data, size, &nbytes, NULL);
		
		// Gg̓o^
		ARCHIVE_ENTRY e;
		e.Name=name;
		e.Size=size;
		e.Data=data;
		Entry.push_back(e);
		
		// Ggt@C
		CloseHandle(h);

		// wb_TCY̌vZ
		DWORD header_size=sizeof(DWORD)*2;
		for (size_t i=0, n=Entry.size(); i<n; i++) {
			header_size+=Entry[i].Name.length()+1;
			header_size+=sizeof(DWORD)*2;
		}
		
		// ItZbǧvZ
		DWORD offset=header_size;
		for (size_t i=0, n=Entry.size(); i<n; i++) {
			Entry[i].Offset=offset;
			offset+=Entry[i].Size+1;
		}
	}
}

// Z[u
bool CArchiveSaver::Save(string name) {

	// [NGÅm
	if (Entry.empty()) return false;
	DWORD work_size=Entry.back().Offset+Entry.back().Size+1;
	char* work=new char[work_size];
	char* p=work+sizeof(DWORD);

	// Gg̏
	*(DWORD*)p=Entry.size();
	p+=sizeof(DWORD);
	
	// Gg̏
	for (size_t i=0, n=Entry.size(); i<n; i++) {
		
		// O
		strcpy(p, Entry[i].Name.c_str());
		p+=Entry[i].Name.length()+1;
		
		// TCY
		*(DWORD*)p=Entry[i].Size;
		p+=sizeof(DWORD);
		
		// ItZbg
		*(DWORD*)p=Entry[i].Offset;
		p+=sizeof(DWORD);
	}
	
	// f[^̏
	for (size_t i=0, n=Entry.size(); i<n; i++) {
		
		// f[^
		memcpy(p, Entry[i].Data, Entry[i].Size);
		p+=Entry[i].Size;
		
		// k
		*p++='\0';
	}
	assert(p-work==work_size);

	// `FbNT
	DWORD sum=0;
	for (DWORD i=4, n=work_size-3; i<n; i+=4) {
		sum+=*(DWORD*)(work+i);
	}
	*(DWORD*)work=sum;

	// XNu
	Rand.Init(Password);
	for (DWORD i=0, n=work_size-3; i<n; i+=4) {
		*(DWORD*)(work+i)^=Rand.Int32();
	}

	// A[JCut@CJ
	HANDLE h=CreateFile(
		name.c_str(), GENERIC_WRITE, 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (h==INVALID_HANDLE_VALUE) return false;
		
	// 
	DWORD nbytes;
	WriteFile(h, work, work_size, &nbytes, NULL);

	// A[JCut@C
	CloseHandle(h);
	
	// [NGẢ
	delete[] work;
	
	return true;
}

// RXgN^i[hj
CArchiveLoader::CArchiveLoader()
:	Work(NULL), WorkSize(0) 
{}

// fXgN^i[hj
CArchiveLoader::~CArchiveLoader() {
	if (Work) delete[] Work;
}

// [h
bool CArchiveLoader::Load(string name) {
	DWORD nbytes;

	// A[JCut@CJ
	HANDLE h=CreateFile(
		name.c_str(), GENERIC_READ, FILE_SHARE_READ, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (h==INVALID_HANDLE_VALUE) return false;

	// TCY𒲂ׂ
	DWORD size=GetFileSize(h, NULL);
	char* data=new char[size];
	
	// [NGÅm
	if (WorkSize<size) {
		if (Work) delete[] Work;
		Work=new char[size];
		WorkSize=size;
	}
	
	// A[JCut@Cǂݍ
	ReadFile(h, Work, size, &nbytes, NULL);
	
	// A[JCut@C
	CloseHandle(h);

	// XNu
	Rand.Init(Password);
	for (DWORD i=0, n=size-3; i<n; i+=4) {
		*(DWORD*)(Work+i)^=Rand.Int32();
	}

	// `FbNT
	DWORD sum=0;
	for (DWORD i=4, n=size-3; i<n; i+=4) {
		sum+=*(DWORD*)(Work+i);
	}
	if (sum!=*(DWORD*)Work) return false;

	// Gg̃NA
	Entry.clear();
	
	// Gg̓ǂݍ
	char* p=Work+sizeof(DWORD);
	DWORD num_entries=*(DWORD*)p;
	p+=sizeof(DWORD);

	// Gg̓ǂݍ
	for (DWORD i=0; i<num_entries; i++) {
		ARCHIVE_ENTRY e;
		
		// O
		e.Name=p;
		p+=e.Name.length()+1;
		
		// TCY
		e.Size=*(DWORD*)p;
		p+=sizeof(DWORD);

		// ItZbg
		e.Offset=*(DWORD*)p;
		p+=sizeof(DWORD);

		// AhX
		e.Data=Work+e.Offset;
		
		// Gg̓o^
		Entry.push_back(e);
	}
	return true;
}

// Gǧ
ARCHIVE_ENTRY* CArchive::Find(string name) {
	for (size_t i=0, n=Entry.size(); i<n; i++) {
		if (name==Entry[i].Name) return &Entry[i];
	}
	return NULL;
}


